# File: Makefile.mak
SHELL=	/bin/sh
# This makefile is for RMPROP 2.1.2.
# This makefile expects the following environment variables to be
# predefined:
#     FTN      compiler command
#     FFLAGS   compiler options
#     LOAD     load command
#     PSSC     list of potential surface source codes
#     CMD      name of executable image
#     SDR      list of machine-dependent source codes
#
# Only one of the following lines defining OBJ should be uncommented
# at any one time.
#
#
#The line below is for the distribution version.
OBJ=	rmprop2.o exscat2.o gnscat2.o verp.o

#The line below is for the Cray-2 version with SCILIB RS.
#OBJ=	rmprop2.o exscat2.o gnscat2.o vercs.o

#The line below is for the Cray-2 version with EV2RSP.
#OBJ=	rmprop2.o exscat2.o gnscat2.o verce.o

#The line below is for the Cray X-MP version with SCILIB RS.
#OBJ=	rmprop2.o exscat2.o gnscat2.o verxs.o

#The line below is for the Cray X-MP version with EV2RSP.
#OBJ=    rmprop2.o exscat2.o gnscat2.o verxe.o

#The two lines below are for the IBM version.
#OBJ=	rmprop2.o exscat2.o gnscat2.o veri.o
#LIBRS=	 /lib/libblas.a

.f.o:
	$(FTN) $(FFLAGS) $*.f

$(CMD):         $(OBJ) $(SDR) $(PSSC)
	$(LOAD) -o $(CMD) $(OBJ) $(SDR) $(PSSC) $(LIBRS)

