# File: Makefile.mak
SHELL=	/bin/sh
# This makefile is for RMPROP 2.1.2.
# This makefile expects the following environment variables to be
# predefined:
#     FTN      compiler command
#     FFLAGS   compiler options
#     LOAD     load command
#     PSSC     list of potential surface source codes (object files)
#     CMD      name of executable image
#     SDR      list of machine-dependent source codes
#
# Only one of the following lines defining OBJ should be uncommented
# at any one time.
#
#
#The line below is for the distribution version.
OBJ=	rmprop2.o exscat2.o gnscat2.o verp.o

#The line below is for the Cray-2 version with SCILIB RS.
#OBJ=	rmprop2.o exscat2.o gnscat2.o vercs.o

#The line below is for the Cray-2 version with EV2RSP.
#OBJ=	rmprop2.o exscat2.o gnscat2.o verce.o

#The line below is for the Cray X-MP version with SCILIB RS.
#OBJ=	rmprop2.o exscat2.o gnscat2.o verxs.o

#The line below is for the Cray X-MP version with EV2RSP.
#OBJ=    rmprop2.o exscat2.o gnscat2.o verxe.o

#The two lines below are for the IBM version.
#OBJ=	rmprop2.o exscat2.o gnscat2.o veri.o
#LIBRS=	 /lib/libblas.a

$(CMD):         $(OBJ) $(SDR) $(PSSC)
	$(LOAD) -o $(CMD) $(OBJ) $(SDR) $(PSSC) $(LIBRS)
exscat2.o: exscat2.f
	$(FTN) $(FFLAGS) exscat2.f
flambda.o: flambda.f
	$(FTN) $(FFLAGS) flambda.f 
gnscat2.o: gnscat2.f
	$(FTN) $(FFLAGS2) gnscat2.f 
prevgr1.o: prevgr1.f
	$(FTN) $(FFLAGS) prevgr1.f 
rmprop2.o: rmprop2.f
	$(FTN) $(FFLAGS) rmprop2.f 
sdrrs6000.o: sdrrs6000.f
	$(FTN) $(FFLAGS) sdrrs6000.f 
verp.o: verp.f
	$(FTN) $(FFLAGS) verp.f
vgr1.o: vgr1.f
	$(FTN) $(FFLAGS) vgr1.f
potatdi.o: potatdi.f
	$(FTN) $(FFLAGS) potatdi.f
dateclock.o: dateclock.c
	cc -O -c dateclock.c
