#!/bin/csh -f
# File: heh2cdr2.csh
# This C shell script is called by runtest.csh to run the test heh2cdr2.
# This script assumes that the following environment variables have been set:
#    DIR, FDIR, SDIR, TDIR, FTN, LOAD, FFLAGS, SDR.
# The script itself creates the variables PSSC and CMD.
#
#NOTE:  It may be simpler to set the above variables here, by hand.
#The following lines, uncommented, would perform this task for the Cray-2
#and Cray XMP/YMP machines.  In this case, the file must be moved from
# /script to the top directory of the distribution package of RMPROP 2.1.2
#setenv DIR `pwd`
#setenv FDIR ${DIR}/src
#setenv SDIR ${DIR}/script
#setenv TDIR ${DIR}/test
#setenv FTN cf77 
#setenv LOAD cf77
#setenv FFLAGS '-c -Wf,"-a static -dp -en"'
#setenv SDR sdrcray.o
#unsetenv LIBRS
#
#             Remove unnecessary files
if ( -f fort.3 ) /bin/rm fort.3
if ( -f fort.4 ) /bin/rm fort.4
if ( -f fort.5 ) /bin/rm fort.5
if ( -f fort.8 ) /bin/rm fort.8
if ( -f fort.15 ) /bin/rm fort.15
if ( -f fort.17 ) /bin/rm fort.17
if ( -f fort.18 ) /bin/rm fort.18
#
#
#             Copy include files to necessary filenames
/bin/cp ${TDIR}/heh2cdr2.param ${FDIR}/parameter.inc
#
#
#             Retrieve input files from /test
/bin/cp ${TDIR}/heh2cdr2.4 fort.4
/bin/cp ${TDIR}/heh2cdr2.5 fort.5   
#
#
#             Set PSSC variable to include all potential-specific
#                   source codes and the CMD variable to the name
#                   of the executable file.
     setenv PSSC "preheh2.o potheh2.o xmat.o"
     setenv CMD rmprop3
#
#             Make the executable
cd ${FDIR}
/bin/make -f ${SDIR}/Makefile.mak
cd ${DIR}
#
#
#             Run the test run
${FDIR}/rmprop3 < fort.5 > heh2cdr2.out   
/bin/cat fort.5 >> heh2cdr2.out
/bin/cat fort.4 >> heh2cdr2.out
/bin/mv fort.3 heh2cdr2.3
/bin/mv fort.7 heh2cdr2.7
/bin/mv fort.11 heh2cdr2.11
/bin/mv fort.15 heh2cdr2.15
/bin/mv fort.16 heh2cdr2.16
