#!/bin/csh -f
# File: heh2tkr2.csh
# This C shell script is called by runtest.csh to run the test heh2tkr1.
# This script assumes that the following environment variables have been set:
#    DIR, FDIR, SDIR, TDIR, FTN, LOAD, FFLAGS, SDR.
# The script itself creates the variables PSSC and CMD.
#
#NOTE:  It may be simpler to set the above variables here, by hand.
#The following lines, uncommented, would perform this task for the Cray-2
#and Cray XMP/YMP machines.  In this case, the file must be moved from
# /script to the top directory of the distribution package of RMPROP 2.1.2
#setenv DIR `pwd`
#setenv FDIR ${DIR}/src
#setenv SDIR ${DIR}/script
#setenv TDIR ${DIR}/test
#setenv FTN cf77 
#setenv LOAD cf77
#setenv FFLAGS '-c -Wf,"-a static -dp -en"'
#setenv SDR sdrcray.o
#unsetenv LIBRS
#
#             Remove unnecessary files
if ( -f fort.3 ) /bin/rm fort.3
if ( -f fort.4 ) /bin/rm fort.4
if ( -f fort.5 ) /bin/rm fort.5
if ( -f fort.8 ) /bin/rm fort.8
if ( -f fort.15 ) /bin/rm fort.15
if ( -f fort.17 ) /bin/rm fort.17
if ( -f fort.18 ) /bin/rm fort.18
#
#
#             Copy include files to necessary filenames
/bin/cp ${TDIR}/heh2tkr.param ${FDIR}/parameter.inc
/bin/cp ${TDIR}/heh2tkr.expand ${FDIR}/expand.inc
#
#
#             Retrieve input files from /test
/bin/cp ${TDIR}/heh2tkr2.4 fort.4
/bin/cp ${TDIR}/heh2tkr2.5 fort.5   
#
#
#             Set PSSC variable to include all potential-specific
#                   source codes and the CMD variable to the name
#                   of the executable file.
     setenv PSSC "prevgr2.o tkrpot.o vgr2.o flambda.o leg.o gaussq.o wdata.o weigh.o "
     setenv CMD rmptkr
#
#             Make the executable
cd ${FDIR}
/bin/make -f ${SDIR}/Makefile.mak
cd ${DIR}
#
#
#             Run the test run
${FDIR}/rmptkr < fort.5 > heh2tkr2.out   
/bin/cat fort.5 >> heh2tkr2.out
/bin/cat fort.4 >> heh2tkr2.out
/bin/mv fort.15 heh2tkr2.15
