#!/bin/csh -f
# File: hfhfadr1.csh
# This C shell script is called by runtest.csh to run the test hfhfadr1.
# This script assumes that the following environment variables have been set:
#    DIR, FDIR, SDIR, TDIR, FTN, LOAD, FFLAGS, SDR.
# The script itself creates the variables PSSC and CMD.
#
#NOTE:  It may be simpler to set the above variables here, by hand.
#The following lines, uncommented, would perform this task for the Cray-2
#and Cray XMP/YMP machines.  In this case, the file must be moved from
# /script to the top directory of the distribution package of RMPROP 2.1.2
#setenv DIR `pwd`
#setenv FDIR ${DIR}/src
#setenv SDIR ${DIR}/script
#setenv TDIR ${DIR}/test
#setenv FTN cf77 
#setenv LOAD cf77
#setenv FFLAGS '-c -Wf,"-a static -dp -en"'
#setenv SDR sdrcray.o
#unsetenv LIBRS
#
#             Remove unnecessary files
if ( -f fort.3 ) /bin/rm fort.3
if ( -f fort.4 ) /bin/rm fort.4
if ( -f fort.5 ) /bin/rm fort.5
if ( -f fort.8 ) /bin/rm fort.8
if ( -f fort.15 ) /bin/rm fort.15
if ( -f fort.17 ) /bin/rm fort.17
if ( -f fort.18 ) /bin/rm fort.18
#
#
#             Copy include files to necessary filenames
/bin/cp ${TDIR}/hfhfadr1.param ${FDIR}/parameter.inc
/bin/cp ${TDIR}/hfhfadr1.expand ${FDIR}/expand.inc
#
#
#             Retrieve input files from /test
/bin/cp ${TDIR}/hfhfadr1.4 fort.4
/bin/cp ${TDIR}/hfhfadr1.5 fort.5   
#
#
#             Set PSSC variable to include all potential-specific
#                   source codes and the CMD variable to the name
#                   of the executable file.
     setenv PSSC "prevgr3.o pothfhfad.o vgr3.o fcoef5.o fcoef.o weigh.o gaussq.o wdata.o yqqm.o leg.o rigptntl.o jsymbol.o cleb2.o "
     setenv CMD rmprop5
#
#             Make the executable
cd ${FDIR}
/bin/make -f ${SDIR}/Makefile.mak
cd ${DIR}
#
#
#             Run the test run
${FDIR}/rmprop5 < fort.5 > hfhfadr1.out   
/bin/cat fort.5 >> hfhfadr1.out
/bin/cat fort.4 >> hfhfadr1.out
/bin/mv fort.3 hfhfadr1.3
/bin/mv fort.8 hfhfadr1.8
/bin/mv fort.14 hfhfadr1.14
/bin/mv fort.15 hfhfadr1.15
