#!/bin/csh -f
# File: hfhfpbsr1.csh
# This C shell script is called by runtest.csh to run the test hfhfpbsr1.
# This script assumes that the following environment variables have been set:
#    DIR, FDIR, SDIR, TDIR, FTN, LOAD, FFLAGS, SDR.
# The script itself creates the variables PSSC and CMD.
#
#NOTE:  It may be simpler to set the above variables here, by hand.
#The following lines, uncommented, would perform this task for the Cray-2
#and Cray XMP/YMP machines.  In this case, the file must be moved from
# /script to the top directory of the distribution package of RMPROP 2.1.2
#setenv DIR `pwd`
#setenv FDIR ${DIR}/src
#setenv SDIR ${DIR}/script
#setenv TDIR ${DIR}/test
#setenv FTN cf77 
#setenv LOAD cf77
#setenv FFLAGS '-c -Wf,"-a static -dp -en"'
#setenv SDR sdrcray.o
#unsetenv LIBRS
#
#                     Remove some files
if ( -f fort.3 ) /bin/rm fort.3
if ( -f fort.4 ) /bin/rm fort.4
if ( -f fort.5 ) /bin/rm fort.5
if ( -f fort.8 ) /bin/rm fort.8
if ( -f fort.10 ) /bin/rm fort.10
if ( -f fort.14 ) /bin/rm fort.14
if ( -f fort.15 ) /bin/rm fort.15
if ( -f fort.17 ) /bin/rm fort.17
if ( -f fort.18 ) /bin/rm fort.18
#             Copy include files to necessary filenames
/bin/cp ${TDIR}/hfhfpbsr1.param ${FDIR}/parameter.inc
/bin/cp ${TDIR}/hfhfpbsr1.expand ${FDIR}/expand.inc
#
#
#             Retrieve input files from /test
/bin/cp ${TDIR}/hfhfpbsr1.4 fort.4
/bin/cp ${TDIR}/hfhfpbsr1.5 fort.5   
#
#
#             Set PSSC variable to include all potential-specific
#                   source codes and the CMD variable to the name
#                   of the executable file.
     setenv PSSC "prehfhfpbs.o pothfhfpbs.o fcoef.o fcoef5.o xmat.o jsymbol.o cleb2.o"
     setenv CMD rmprop4
#
#             Make the executable
cd ${FDIR}
/bin/make -f ${SDIR}/Makefile.mak
cd ${DIR}
#
#
#             Run the test run
${FDIR}/rmprop4 < fort.5 > hfhfpbsr1.out   
/bin/cat fort.5 >> hfhfpbsr1.out
/bin/cat fort.4 >> hfhfpbsr1.out
/bin/mv fort.3 hfhfpbsr1.3
/bin/mv fort.15 hfhfpbsr1.15
