      SUBROUTINE CLEB2(JA,JB,JC,MA,MB,MC,F,NDIMF,LZERO,IFIND)
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)
      SAVE
      LOGICAL LZERO
C----------------------------------------------------------------------
C THIS PROGRAM WAS WRITTEN BY G. A. PARKER 1/3/77.  FOR A
C DESCRIPTION FO THE ALGORITHM USED SEE KLAUS SCHULTEN AND R. G.
C GORDON  JMP 16,1961,(1975).
C THIS PROGRAM IS MOST EFFICIENT WHEN A SERIES OF CLEBSCH-
C GORDAN COEFFICIENTS ARE DESIRED
C THIS ROUTINE HAS BEEN MODIFIED TO USE THE RECURSION OVER M2 RATHER
C THAN J1.
C----------------------------------------------------------------------
      DIMENSION F(NDIMF)
      DATA J1OLD,J2OLD,J3OLD,M1OLD/-1,-1,-1,-1/
      DATA ZERO,EPS,ONE,TWO/0.0D+0,1.0D-8,1.0D+0,2.0D+0/
C----------------------------------------------------------------------
C STATEMENT FUNCTIONS USED IN RECURRENCE RELATIONS.
C----------------------------------------------------------------------
      C(XM2)=DSQRT((XJ2P-XM2)*(XJ2+XM2)*(XJ3M1P-XM2)*(XJ3M1+XM2))
      D(XM2)=XJ123-TWO*XM2*(XM2+XM1)
C----------------------------------------------------------------------
C CHECK TRIANGLE INEQUALITIES.
C----------------------------------------------------------------------
      LZERO=.FALSE.
      IF (IABS(MC) .GT. JC) GO TO 220
      IF (IABS(MB) .GT. JB) GO TO 220
      IF (IABS(MA) .GT. JA) GO TO 220
      IF (MC .NE. MA+MB) GO TO 220
C----------------------------------------------------------------------
C CALCULATE MAXIMUM AND MINIMUM ALLOWED VALUES OF M2
C----------------------------------------------------------------------
      J1 = JA
      J2 = JB
      J3 = JC
      M1 = MA
      M2 = MB
      M3 = -MC
      M2MAX=MIN0(J2,J3-M1)
      M2MIN=MAX0(-J2,-J3-M1)
      M2MINM=M2MIN-1
      M2MAXP=M2MAX+1
      IF (M2 .GT. M2MAX .OR. M2 .LT. M2MIN) GO TO 220
C----------------------------------------------------------------------
C CHECK TO SEE IF THE CLEBSCH-GORDAN COEFFICIENT HAS ALREADY
C DETERMINED.
C----------------------------------------------------------------------
      IF(J1OLD.NE.J1)GOTO 100
      IF (J2OLD .NE. J2) GO TO 100
      IF (J3OLD .NE. J3) GO TO 100
      IF (M1OLD .NE. M1) GO TO 100
C     GO TO 190
C----------------------------------------------------------------------
C COEFFICIENTS HAVE NOT BEEN PREVIOUSLY DETERMINED.
C----------------------------------------------------------------------
  100 J2OLD = J2
      J3OLD = J3
      M1OLD = M1
      J1OLD=J1
C----------------------------------------------------------------------
C DETERMINE CONSTANTS FOR STATEMENT FUNCTIONS.
C----------------------------------------------------------------------
      XJ2= DBLE(J2)
      XJ2P=XJ2+ONE
      XJ123= DBLE(J2*(J2+1)+J3*(J3+1)-J1*(J1+1))
      XJ3M1P= DBLE(J3+1-M1)
      XJ3M1= DBLE(J3+M1)
      XM1= DBLE(M1)
C----------------------------------------------------------------------
C DETERMENE WHERE THE MIDDLE COEFFICIENT IS LOCATED AND THE
C NUMBER OF COEFFICIENTS.
C----------------------------------------------------------------------
      NCOEF = M2MAX-M2MIN+1
      IF(NCOEF.LE.NDIMF)GOTO 230
      WRITE(6,231)NDIMF,NCOEF
  231 FORMAT(1X,24HDIMENSIONS IN CLEB2 ARE ,I5, 7H WHILE ,I5,10H IS NEED
     $ED)
      STOP
  230 CONTINUE
      MID = NCOEF/2+1
      IF (NCOEF .LE. 2) GO TO 200
C----------------------------------------------------------------------
C SET INITIAL VALUES FOR THE COEFFICIETTS F(1) AND F(NCOEF).
C----------------------------------------------------------------------
      F(1) = ONE
      F(NCOEF) = ONE
C----------------------------------------------------------------------
C USE EQUATIONS 20 AND 21 FROM THE REFERENCE TO DETERMINE
C F(2) AND F(NCOEF-1)
C----------------------------------------------------------------------
      XM2= DBLE(M2MIN)
      XM2P=XM2+ONE
C     PRINT*,J1,J2,J3,M1,M2,M3,M2MIN,M2MAX
      TEMP1=D(XM2)
      TEMP2=C(XM2P)
C     PRINT*,'NUM & DEN',TEMP1,TEMP2
      F(2)=-D(XM2)/C(XM2P)
      G=F(2)
C     PRINT*,'F(2)',F(2)
      N2=NCOEF-1
      XM2= DBLE(M2MAX)
C     TEMP1=D(XM2)
C     TEMP2=C(XM2)
C     PRINT*,'NUM & DEN',TEMP1,TEMP2
      F(N2)=-D(XM2)/C(XM2)
C     PRINT*,'F(N2)',F(N2),N2
      MID1 = MID-1
      IF (NCOEF .EQ. 3) GO TO 140
C----------------------------------------------------------------------
C START RECURSIVE EVALUATION OF THE COEFFICIENTS USING
C EQUATION 9'.
C----------------------------------------------------------------------
      DO 130 I = 2,MID1
      IP1 = I+1
      IM1 = I-1
      XM2= DBLE(I+M2MINM)
      XM2P= DBLE(IP1+M2MINM)
      C1=C(XM2)
      C2=C(XM2P)
      D1=D(XM2)
C     PRINT*,'DEN',C2
      G=-(D1*F(I)+C1*F(IM1))/C2
      N2 = NCOEF-I+1
      IF (N2 .EQ. MID) GO TO 140
      F(IP1) = G
C     PRINT*,'F(IP1)',F(IP1),IP1
      IP1=N2+1
      IM1=N2-1
      XM22= DBLE(M2MAXP-I)
      XM22P=XM22+ONE
      D11=D(XM22)
      C11=C(XM22)
      C22=C(XM22P)
C     PRINT*,'DEN',C11
      F(IM1)=-(C22*F(IP1)+D11*F(N2))/C11
C     PRINT*,'F(IM1)',F(IM1),IM1
  130 CONTINUE
C----------------------------------------------------------------------
C MATCH AT THE MIDPOINT.
C----------------------------------------------------------------------
  140  CONTINUE
      IF (ABS(G) .GT. EPS  ) GO TO 150
C     PRINT*,'SMALL G',JA,JB,JC,MA,MB,MC
      I = MID
      IM1 = MID1
      XM2PP=XM2P+ONE
C***THE LINE BELOW WITH C2 IS A TEST FOR ODD PARITY! BY MJU AND DWS 6-1-93
      C2=C(XM2P)
      C3=C(XM2PP)
      D2=D(XM2P)
C     PRINT*,'G DEN',C3
      G=-(D2*F(I)+C2*F(IM1))/C3
C     PRINT*,'G',G
      MID1 = MID
      MID = MID+1
  150 COEF = F(MID)/G
      DO 160 I = 1,MID1
  160 F(I) = COEF*F(I)
C     PRINT*,'F"S',(F(I),I=1,NCOEF)
C---------------------------------------------------------------------
C FIND MAGNITUDE OF THE NORMALIZATION COEFFICIENT.
C----------------------------------------------------------------------
      SUM = ZERO
      DO 170 I = 1,NCOEF
  170 SUM = SUM+F(I)*F(I)
C     PRINT*,'SUM',SUM
      COEF = DSQRT(ONE/(SUM* DBLE(2*J1+1)))
C     PRINT*,'COEF',COEF
C----------------------------------------------------------------------
C DETERMINE SIGN OF THE NORMALIZATION COEFFICIENT.
C----------------------------------------------------------------------
      SIG = ONE
      J = J2-J3-M1
      IF ((J/2)*2 .NE. J) SIG = -ONE
      COEF = DSIGN(COEF,SIG)
C----------------------------------------------------------------------
C NORMALIZE TO OBTAIN THE CLEBSCH-GORDAN COEFFICIENTS.
C----------------------------------------------------------------------
      Y =  DBLE(2*J3+1)
      Y = DSQRT(Y)
      J3M3=J1-J2-M1-M2MIN
      IF ((J3M3/2)*2 .NE. J3M3) Y = -Y
      DO 180 I = 1,NCOEF
      F(I) = COEF*F(I)*Y
  180 Y=-Y
C     PRINT*,'COEF"S',(F(I),I=1,NCOEF)
  190 IFIND=M2-M2MIN
C     PRINT*,'I',I
C     CLEB2= F(I)
      RETURN
  200 IF (NCOEF .EQ. 2) GO TO 210
C----------------------------------------------------------------------
C SPECIAL CASE FOR ONLY 1 COEFFICIENT.
C----------------------------------------------------------------------
      Y =   DBLE(2*J3+1)
      X =   DBLE(2*J1+1)
      J=J1-J3+M3-M1
      SIG = ONE
      IF ((J/2)*2 .NE. J) SIG = -ONE
      F(1) = DSQRT(Y/X)*SIG
C     PRINT*,'F(1)',F(1)
      GO TO 190
C----------------------------------------------------------------------
C SPECIAL CASE FOR ONLY 2 COEFFICIENTS.
C----------------------------------------------------------------------
  210 F(1) =  ONE
      XM2= DBLE(M2MIN)
      XM2P=XM2+ONE
      F(2)=-D(XM2)/C(XM2P)
      SUM= DBLE(2*J1+1)*(F(1)*F(1)+F(2)*F(2))
      COEF = DSQRT(ONE  /SUM)
      SIG = ONE
      J = J2-J3-M1
      IF ((J/2)*2 .NE. J) SIG = -ONE
      COEF = DSIGN(COEF,SIG)
      Y =  DBLE(2*J3+1)
      Y = DSQRT(Y)
      J3M3=J1-J2-M1-M2MIN
      IF ((J3M3/2)*2 .NE. J3M3) Y = -Y
      F(1) = COEF*Y*F(1)
      F(2) = -COEF*Y*F(2)
C     PRINT*,'F(1),F(2)',F(1),F(2)
      GO TO 190
C----------------------------------------------------------------------
C TRIANGLE INEQUALITIES WERE NOT SATISFIED.
C----------------------------------------------------------------------
  220 LZERO=.TRUE.
      RETURN
C----------------***END-CLEB***---------------------------------------
      END
