      FUNCTION FCOEF(J1,J2,J12,L,J1P,J2P,J12P,LP,JTOT,IQ1,IQ2,IMU)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE

C***This function is for use with RMPROP: Version 2.1.2.
C***FCOEF may be called by SUBROUTINE CBLOCK (from Schwenke-Truhlar 3-D HF-HF 
C***potential subroutine, in module 'stpot2.f').
C***FCOEF may be called by SUBROUTINE ANGINT (within arbitrary 3-D diatom-
C***diatom potential subroutine in module 'vgr3.f').
C***Calculate angular integrals for Launay expansion of diatom-
C***diatom potential.
C***These are in the space fixed frame.

      DATA TWO/2.0D+0/ZERO/0.0D+0/
      DATA SR2/1.414213562373095D+0/
      FCOEF=ZERO
      IF(MOD(J1+J1P+IQ1,2).NE.0.OR.MOD(J2+J2P+IQ2,2).NE.0.OR.J1+J1P.LT.
     1IQ1.OR.ABS(J1-J1P).GT.IQ1.OR.J2+J2P.LT.IQ2.OR.ABS(J2-J2P).GT.IQ2)
     1RETURN
      F1=F3J(J1,IQ1,J1P,0,0,0,2)
      IF(F1.EQ.ZERO)RETURN
      F2=F3J(J2,IQ2,J2P,0,0,0,2)
      IF(F2.EQ.ZERO)RETURN
      IQ12MX=IQ1+IQ2+1
      IQ12MN=ABS(IQ1-IQ2)+1
      SUM=ZERO
      DO 1 I=IQ12MN,IQ12MX
         IQ12=I-1
         IQ=IQ1+IQ2+IQ12
         IF(MOD(IQ,2).NE.0)GOTO 1
         G1=F3J(LP,IQ12,L,0,0,0,2)
         IF(G1.EQ.ZERO)GOTO 1
         G2=F3J(IQ12,IQ1,IQ2,0,IMU,-IMU,2)
         IF(G2.EQ.ZERO)GOTO 1
         G3=F6J(L,LP,IQ12,J12P,J12,JTOT,2)
         IF(G3.EQ.ZERO)GOTO 1
         G4=F9J(J12P,J2P,J1P,J12,J2,J1,IQ12,IQ2,IQ1,2)
         IF(G4.EQ.ZERO)GOTO 1
         SUM=SUM+G1*G2*G3*G4* DBLE(2*IQ12+1)
    1 CONTINUE
      IF(SUM.EQ.ZERO)RETURN
      F3A=(2*J1+1)*(2*J2+1)*(2*J12+1)*(2*J1P+1)*(2*J2P+1)*(2*J12P+1)
      F3B=(2*L+1)*(2*LP+1)*(2*IQ1+1)*(2*IQ2+1)
      F3=DSQRT(F3A)*DSQRT(F3B)
      FCOEF=F1*F2*F3*SUM
      IF(IMU.NE.0)FCOEF=FCOEF*SR2
      IF(MOD(J1+J2+J12P+JTOT+IQ1+IQ2,2).NE.0)FCOEF=-FCOEF
      RETURN
      END
