      FUNCTION FCOEF5(J1,J2,L,J1P,J2P,LP,IQ1,IQ2,IMU,MMAX,MMIN)
      IMPLICIT DOUBLE PRECISION   (A-H,O-Z)
      SAVE

C***This subroutine is for use with RMPROP: Vesion 2.1.2.
C***FCOEF5 may be called by SUBROUTINE CBLOCK (from Schwenke-Truhlar 3-D HF-HF
C***potential subroutine, in module 'stpot2.f').
C***FCOEF5 may be called by SUBROUTINE ANGINT (within arbitrary 3-D diatom-
C***diatom potential subroutine in module 'vgr3.f').
C***Calculate angular integrals for Launay type diatom-diatom
C***potential expansion. This version is valid only for JTOT=0.
C***The triangle relations are assumed checked.
C***MMAX AND MMIN are defined below.
C***MMAX=MIN0(J1,J2,J2P-IMU,J1P-IMU)
C***MMIN=MAX0(-J1,-J2,-J2P-IMU,-J1P-IMU)

      LOGICAL LZERO
      PARAMETER (MXMS=50)
      DIMENSION G1(MXMS),G2(MXMS),G3(MXMS),G4(MXMS)
      DATA ZERO/0.0D+0/

C***Check triangle relation and zero conditions.

      FCOEF5=ZERO
C     IF(J2+J2P.LT.IQ2)RETURN
C     IF(J1+J1P.LT.IQ1)RETURN
C     IF(ABS(J2-J2P).GT.IQ2)RETURN
C     IF(ABS(J1-J1P).GT.IQ1)RETURN
C     IF(MOD(J2+J2P+IQ2,2).NE.0)RETURN
C     IF(MOD(J1+J1P+IQ1,2).NE.0)RETURN
C     IF(J12.NE.L)RETURN
C     IF(J12P.NE.LP)RETURN

C***Calculate sum first - this way in case it is zero, we avoid
C***calculating the 2 3J symbols in front which we know are not zero.

C     IF(MMAX.LT.MMIN)RETURN
      CALL CLEB2(L,J1,J2,0,MMIN,MMIN,G1,MXMS,LZERO,I1)
      IF(LZERO)RETURN
      M2=IMU+MMIN
      CALL CLEB2(LP,J1P,J2P,0,M2,M2,G2,MXMS,LZERO,I2)
      IF(LZERO)RETURN
      CALL CLEB2(IQ1,J1P,J1,-IMU,M2,MMIN,G3,MXMS,LZERO,I3)
      IF(LZERO)RETURN
      CALL CLEB2(IQ2,J2P,J2,-IMU,M2,MMIN,G4,MXMS,LZERO,I4)
      IF(LZERO)RETURN
      SUM=ZERO
      NUMTER=MMAX-MMIN+1
      DO 1 I=1,NUMTER
    1 SUM=SUM+G1(I+I1)*G2(I+I2)*G3(I+I3)*G4(I+I4)
      IF(SUM.EQ.ZERO)RETURN

C***The coefficient is not zero.

      CALL CLEB2(J1,IQ1,J1P,0,0,0,G1,MXMS,LZERO,I1)
      F1=G1(I1+1)
      CALL CLEB2(J2,IQ2,J2P,0,0,0,G1,MXMS,LZERO,I1)
      F2=G1(I1+1)
      ITOP=(2*IQ1+1)*(2*IQ2+1)*(2*L+1)*(2*LP+1)
      IBOT=(2*J2+1)*(2*J2P+1)
      IF(IMU.NE.0)ITOP=2*ITOP
      FCOEF5=DSQRT( DBLE(ITOP)/ DBLE(IBOT))*F1*F2*SUM
      IF(MOD(IQ1+IMU,2).NE.0)FCOEF5=-FCOEF5
      RETURN
      END
