      SUBROUTINE LEG(PL,L,G)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***LEG may be called by EXPGET (from generalized atom-diatom
C***potential subroutine, in module 'vgr2.f').
C***LEG may be called from within SUBROUTINE WEIGH (general routine to
C***determine weights and nodes for quadratures over vibrational contribution
C***to potential matrix elements, in module 'weigh.f').
C***This calculates the Legendre polynomials of order 0 to L-1
C***with argument G and stores the result in PL.

      DIMENSION PL(L)
      PL(1)=1D0
      IF(L.EQ.1)RETURN
      PL(2)=G
      IF(L.EQ.2)RETURN
      DO 10 I=3,L
      PL(I)=((2D0*DBLE(I)-3D0)*G*PL(I-1)-(DBLE(I)-2)*PL(I-2))/
     1(DBLE(I)-1D0)
10    CONTINUE
      RETURN
      END
