         SUBROUTINE FUN1(R,LMAXP1,VL)
         IMPLICIT DOUBLE PRECISION(A-H,O-Z)

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***FUN1 is called by SUBROUTINE POT (general 3-D atom-rigid diatom
C***potential routine, in module 'vgr1.f').
C***This subroutine calculates the radial-dependent
C***expansion coefficients for a collinear atom-diatom potential which
C***is expanded in Legendre functions.

C***Potential approximation (Lester and Bernstein).

        INCLUDE 'parameter.inc'
        DIMENSION VL(NVIB1X),ALAMB(2)
        DATA ALAMB/1.D0,0.2283D0/
        DATA ONE,TWO,SIX,TWELVE/1.0D0,2.0D0,6.0D0,1.2D+01/

C***Initialize things.

        DO 5 I=1,LMAXP1
           VL(I)=0.0D0
    5   CONTINUE

C***Calculate expansion coefficients from input parameters.

        V0=((ONE/R**TWELVE)-(TWO/(R**SIX)))
        DO 10 I=1,LMAXP1
        NI=(I-1)/2 +1
   10   VL(NI)=V0*ALAMB(NI)
        RETURN
        END
      DOUBLE PRECISION FUNCTION EIGEN(IV,JI)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***EIGEN is called by SUBROUTINE PREPOT (Lester-Bernstein atom-diatom
C***potential routine, in module 'preatdi.f').

C     INCLUDE 'parameter.inc'
C     INCLUDE 'expand.inc'
      DATA BIGB,ROT/1000.D0,2.3510D0/
      EIGEN=DBLE(JI*(JI+1))
      EIGEN=EIGEN*ROT
      EIGEN=EIGEN/BIGB
      RETURN
      END
      SUBROUTINE HEADER

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***HEADER is called by SUBROUTINE PREPOT (Lester-Bernstein atom-diatom
C***potential routine, in module 'preatdi.f').

      SAVE
      WRITE(6,10)
      WRITE(15,10)
   10 FORMAT(/1X,49HThe potential of W. A. Lester and R. B. Bernstein,
     1/1X,36HChem. Phys. Lett. 1, 207-210 (1967) )
      RETURN
      END
