      SUBROUTINE FUN1(R,LMAXP1,VL)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.
C***FUN1 is called by POT (generalized 3-D atom-rigid diatom potential
C***subroutine in module 'vgr1.f').
C***This subroutine calculates the radial-dependent expansion coefficients
C***for a collinear atom-diatom potential which is expanded in
C***Legendre functions.

C***Potential approximation (Collins and Lane, HE-HF).

      INCLUDE 'parameter.inc'
      DIMENSION VL(NVIB1X)
      DIMENSION AL(5,3),ML(5)
      DATA AL/128.275,10.356,29.253,10.739,3.875,                       5M16R94
     & 2.494,2.151,2.379,2.173,2.115,                                   5M16R94
     & 3.42,6.78,1.55,1.41,1.23/                                        5M16R94
      DATA ML/6,7,6,7,8/                                                5M16R94
      DATA NL,ROL/6,5.0/                                                5M16R94
C***Initialize things.

        DO 5 I=1,LMAXP1
           VL(I)=0.0D0
    5   CONTINUE

C***Calculate expansion coefficients

        RRN=(R/ROL)**NL
        DO 10 I=1,LMAXP1
           VSRL=AL(I,1)*EXP(-AL(I,2)*R)
           VLRL=-AL(I,3)*(1.0D0-EXP(-RRN))/R**ML(I)
   10   VL(I)=VSRL+VLRL
        RETURN
        END
      SUBROUTINE HEADER
      WRITE(6,8)
      WRITE(15,8)
    8 FORMAT(/1X,51HThe potential given by L. A. Collins and N. F. Lane
     1,/1X,32HPhys. Rev. 14, 1385 (76) Is used)
      RETURN
      END
      DOUBLE PRECISION FUNCTION EIGEN(IV,JI)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      PARAMETER (B=0.954000D-04)
         EIGEN=B*DBLE(JI*(JI+1))
      RETURN
      END
