      SUBROUTINE PREPOT(LSTAP,NDIM,JIN,ID,L,JTOT,B,IS,EI,EFASY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER FU4
      SAVE
C***This subroutine is for use with RMPROP: Version 2.1.2.
C***PREPOT is called by PROGRAM RMPROP.
C***   MAXPRM is the maximum number of primitive basis functions.
C***   LHOSC determines whether we treat the molecule as a Morse oscillator
C***   or as a harmonic oscillator.
C***   LSRIES determines whether the interaction potential is treated
C***   as 
C***       for LSRIES = .TRUE.   a sum of inverse powers of R (R**-P)
C***       for LSRIES = .FALSE.  a decaying exponential EXP(-ALPHA*R).

      PARAMETER(FU4=4)
      INCLUDE 'parameter.inc'
      PARAMETER (MAXPRM=40,IBDIM=MAXPRM*(MAXPRM+1)/2)
      PARAMETER (NMAX=12)
      DIMENSION WV2(2,2)
      DIMENSION IS(IDX,NVIBX),EI(IDX),JIN(IDX,NANX),L(IDX),
     1B(IDX,IDX,NVIB1X),EFASY(IDX,IDX)
      COMMON/OSCCOM/LHOSC,LSRIES
      COMMON/APRXCM/V0,ALPHA,BETA,MCBC,AMORSE,DMORSE,HOSCK,OMEGA
      DOUBLE PRECISION MCBC
      LOGICAL LSTAP,LHOSC,LSRIES
      DATA WV2/9.929272D-01,-1.187247D-01,1.187247D-01,9.929272D-01/

C***Call subroutine HEADER to print a description of the potential.

      CALL HEADER
      OPEN(UNIT=FU4,FILE='fort.4',STATUS='OLD',FORM='FORMATTED')
      LSRIES=.FALSE.
      READ(4,5001) LSTAP,LHOSC
      READ(4,5000) V0,ALPHA,BETA,MCBC,OMEGA
      IF(LHOSC) GO TO 76
      READ(4,5000) AMORSE,DMORSE,HOSCK
 5000 FORMAT(5G15.6)
 5001 FORMAT(5L1)
   76 CONTINUE

C***Trap to check dimensions.

      IF(NDIM.GT.MAXPRM)THEN
      MAXPRN=MAXPRM
      WRITE(6,9919)NDIM,MAXPRN
 9919 FORMAT(1X,46HIn subroutine PREPOT, dimensions are exceeded.,/
     11X,21HIncrease MAXPRM from ,I5,1X,27Hto be greater than or equal,
     21X,16Hto NDIM which is,I5)
      STOP 'STOP in SUBROUTINE PREPOT in preheh2.f'
      ENDIF

C***Title approximation: write information about input.

      WRITE(6,5) ALPHA
      WRITE(6,7) BETA
      IF(LHOSC)WRITE(6,9)
      IF(.NOT.LHOSC)WRITE(6,11)AMORSE,DMORSE,HOSCK
      WRITE(6,13)MCBC
    5 FORMAT(//1X,47HThe potential matrix elements will be evaluated,
     155H for an asymptotic harmonic oscillator primitive basis./1X,
     251Hdefine ALPHA=SQRT(1.0/(2.0*reduced mass*frequency)./1X,
     36HALPHA=,F10.5)
    7 FORMAT(/1X,44HThe interaction between the nearest neighbor,
     156H atoms A and B is taken as an exponential repulsion with,
     225H strength parameter BETA./1X,5HBETA=,F10.5)
    9 FORMAT(/1X,41HThe molecule BC is treated as a harmonic ,
     144Hoscillator for which ALPHA is defined above.)
   11 FORMAT(/1X,49HThe molecule bc is treated as a Morse oscillator ,
     160Hfor which the potential requires the multiplicative constant/
     21X,35HDMORSE and for the exponent AMORSE./1X,7HAMORSE=,F10.4,
     310X,7HDMORSE=,F10.5,10X/1X,27HThe force constant for the ,
     447Hharmonic oscillators of the basis set is HOSCK./1X,6HHOSCK=,
     5F10.5)
   13 FORMAT(/1X,34HMCBC is the mass ratio MC/(MB+MC)./1X,5HMCBC=,
     1F10.5)

C***Find internal molecular energy levels.

      CALL EINT(NDIM,ID,EI,IS,OMEGA)

C***Energy and sector independent quantities.
C***Set asymptotic basis set.

      DO 92 I=1,NDIM
      DO 93 J=1,NDIM
   93    EFASY(J,I)=0.0D+0
   92    EFASY(I,I)=1.0D+0
      RETURN
      END
