      SUBROUTINE PREPOT(LSTAP,NDIM,J,ID,L,JTOT,BPOT,IS,EI,EFCN)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER FU4
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***Modular potential interface for pre-expanded atom-rigid rotor potentials.
C***PREPOT is Called by PROGRAM RMPROP.

      PARAMETER(FU4=4)
      INCLUDE 'parameter.inc'

C***Common /FACT/ below is needed for FLAMB for Percival-Seaton coefficients.

      COMMON/FACT/DUM1(999),NCALL

C***Common /JCM/ below is needed for the potential matrix routine (POT).

      COMMON/JCM/JL(IDX),JTOTAL,IHOM,LAMMAX,LAMMIN

C***For BPOT below, NVIB1X must be at least LAMMAX+1.

      DIMENSION J(IDX,NANX),L(IDX),BPOT(IDX,IDX,NVIB1X),EFCN(IDX,IDX),
     1          EI(IDX),IS(IDX,NVIBX)

      LOGICAL LSTAP

      DATA ZERO, ONE/0.0D+0,1.0D+0/

      JTOTAL=JTOT
      NCALL=0

C***Call subroutine HEADER to write a description of the potential.
      CALL HEADER

C***Read potential expansion information from Unit 4
      OPEN(UNIT=FU4,FILE='fort.4',STATUS='OLD',FORM='FORMATTED')
      READ(4,7)LSTAP
    7 FORMAT(L1)
C                      CHANGING ALL ID's to NDIM's                      5M13R94
      READ(4,8)(J(I,1),I=1,NDIM)                                        5M13R94
    8 FORMAT(10I5)
      READ(4,8)IHOM,LAMMAX                                              5M16R94
C
      DO 6 II=1,NDIM                                                    5M13R94
         JL(II)=J(II,1)
    6 CONTINUE

      DO 93 II=1,NDIM                                                   5M16R94
          DO 93 JJ=1,NDIM                                               5M13R94
             DO 93 IK=0,LAMMAX,IHOM                                     5M16R94
                IKL=(IK/IHOM)+1                                         5M16R94
                BPOT(II,JJ,IKL)=BPOT(II,JJ,IKL)+FLAMB(J(II,1),L(II),
     &           J(JJ,1),L(JJ),JTOT,IK)                                 5M16R94
93    CONTINUE

C***Get internal energies of monomer.

      DO 19 I=1,NDIM                                                    5M13R94
        EI(I)=EIGEN(1,JL(I))
   19 CONTINUE

C***Set asymptotic basis set.

      DO 20 I=1,NDIM                                                    5M16R94
         DO 18 K=1,NDIM                                                 5M16R94
            EFCN(K,I)=ZERO                                              5M16R94
18       CONTINUE                                                       5M16R94
         EFCN(I,I)=ONE                                                  5M16R94
20    CONTINUE                                                          5M16R94
      RETURN
      END
