      SUBROUTINE PREPOT(LSTAP,NDIM,JIN,ID,L,JTOT,B,IS,EI,EFCN) 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DOUBLE PRECISION MES 
      LOGICAL LSTAP ,LVIBJ
      INTEGER FU2,FU4
      SAVE
      PARAMETER(FU2=2,FU4=4)
      INCLUDE 'parameter.inc'

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***PREPOT is called once before the first call to POT.
C***PREPOT is called by PROGRAM RMPROP.
C***POT is called by PROGRAM RMPROP and by SUBROUTINE MATCH.
C***POT is only called by SUBROUTINE MATCH depending on input data.

      COMMON/JHOMCM/IHOM,JHOM
      COMMON/RECM/REE

      DIMENSION IS(IDX,NVIBX),EI(IDX),JIN(IDX,NANX),L(IDX),
     1B(IDX*IDX*NVIB1X),EFCN(IDX,IDX),UPCDMT(IDX,IDX)

C***Suggested dimensions IQ1(NUMT),IQ2(NUMT),IMU(NUMT),
C***where NUMT is the nunber of terms in the potential expansion.

      DIMENSION IQ1(205),IQ2(205),IMU(205)
      DIMENSION MES(10)
      COMMON/LOGCM/LVIBJ
      COMMON/SROWCM/IRWSPT,IRWNEG
      COMMON/PTIMCM/PTIME(10)
      COMMON/PRPTCM/RE,JTOTAL,NUMQ,NQUAD(10),NQUADA(10),RQUAD(10)
      DATA ND1,ND2,ND3,ND4/186,3*12/
      DATA NNUMT/205/
      DATA ONE/1.0D+0/HALF/0.5D+0/FOUR/4.0D+0/
      DATA IFS/-1/ZERO/0.0D+0/

      LVIBJ=.TRUE.
      IHOM=1

C***Call subroutine HEADER.

      CALL HEADER
      JTOTAL=JTOT
      OPEN(UNIT=FU4,FILE='fort.4',STATUS='OLD',FORM='FORMATTED')

C***RE is the equilibrium displacement of the oscillators.
C***NUMQ is the number of different orders of quadrature or different
C***potential expansions we will use.

      READ(4,35)RE
      REE=RE
      READ(4,325)NUMQ
      RQUAD(1)=ZERO

C***NQUAD(I) is the number of points used in the VIB. quadrature for R
C***less than RQUAD(I), and NQUADA(I) is the number of points used
C***in the angular quadrature.  RQUAD(I) is not needed if NUMQ is one.

      READ(4,325)(NQUAD(I),I=1,NUMQ)
      READ(4,325)(NQUADA(I),I=1,NUMQ)
      IF(NUMQ.GT.1)READ(4,35)(RQUAD(I),I=1,NUMQ-1)

C***LSTAP is FALSE if RMPROP will call PREPOT to define the next POT.

      READ(4,326)LSTAP

C***Possibly read some text and write it to the output.

      READ(4,325)NLINE
      IF(NLINE.EQ.0)RETURN
      DO 33 I=1,NLINE
         READ(4,36)MES
   33 WRITE(6,34)MES
   34 FORMAT(1X,80A8)
   35 FORMAT(9E15.8)
   36 FORMAT(80A8)
  325 FORMAT(10I5)
  326 FORMAT(L1)

C***Set times to zero.

      DO 8172 I=1,10
 8172    PTIME(I)=0.0
      ICALL=0

C***Do things which need be done only once.

      IBMX=ID*ID*NVIB1X
      NUMQSF=1
      SRH=DSQRT(HALF)

C***Read switch which controls whether or not integrals in ANGINT
C***are just calculated and written to TAPE2 or read from TAPE2.
C***0 means calculate and continue without writting.
C***1 means calculate and write.
C***2 means read.

      READ(4,55)ICOR
      IF(ICOR.EQ.1)WRITE(6,90)
      IF(ICOR.EQ.2)WRITE(6,91)
   90 FORMAT(1X,41HIntegrals in ANGINT are to be calculated,
     $,22H and written to TAPE2.)
   91 FORMAT(1X,38HIntegrals in ANGINT are to be read in.)

C***Read in vibrational channels.

      READ(4,55)(IS(IJ,1),IJ=1,NDIM)
      READ(4,55)(IS(IJ,2),IJ=1,NDIM)

C***Read in rotational channels.

      READ(4,55)(JIN(IJ,1),IJ=1,NDIM)
      READ(4,55)(JIN(IJ,2),IJ=1,NDIM)
      READ(4,55)(JIN(IJ,3),IJ=1,NDIM)

C***Read in exchange value; eigenvalue is (-1)**IETA.
C***IVIBJ zero means use J-dependent vibrational states, non-zero
C***use J-independent vibrational states.
C***ISYMU zero means use exchange symmetry, non zero don't use it.

      READ(4,55)IETA,IVIBJ,ISYMU

C***Write things.

   55 FORMAT(10I5)
      NQADAG=NQUADA(NUMQSF)
      NQUADV=NQUAD(NUMQSF)
      ISTART=1
      WRITE(6,15)RE,NQUADV
   15 FORMAT(/1X,4HRE =,1PE15.8/1X,13HInitially use,I4,40H point quadraT
     1ure for vib. integrals and,/1X,31Hmixed vib-angular integrals for,
     247H coefficients used in building potential matrix)

      IF(ISYMU.EQ.0.AND.MOD(IETA,2).EQ.0)WRITE(6,75)
   75 FORMAT(/1X,114HThe channels are even eigenstates of exchange parit
     1y, and so if N1 & N2 and J1 & J2 are reversed, nothing changes.)
      IF(ISYMU.EQ.0.AND.MOD(IETA,2).NE.0)WRITE(6,76)
   76 FORMAT(/1X,119HThe channels are odd eigenstates of exchange parity
     1, and so if N1 & N2 and J1 & J2 are reversed, only the sign change
     2s.)
      WRITE(6,44)(I,IS(I,1),IS(I,2),JIN(I,1),JIN(I,2),JIN(I,3),L(I),
     1I=1,NDIM)
   44 FORMAT(/1X,49HChannel labels in the order (#,N1,N2,J1,J2,J12,L)/(
     11X,3(1H(,I3,6(1H,,I3),1H),1H,)))
      IF(IVIBJ.EQ.0)WRITE(6,1)
    1 FORMAT(/1X,76HThe matrix elements over vibrational eigenfunctions 
     1include vib-rot coupling )
      IF(IVIBJ.NE.0)WRITE(6,2)
    2 FORMAT(/1X,83HThe matrix elements over vibrational eigenfunctions 
     1do not include vib-rot coupling )

C***Calculate channel eigen energies.

      DO 361 I=1,NDIM
         EI(I)=EIGEN(IS(I,1),JIN(I,1))+EIGEN(IS(I,2),JIN(I,2))
  361 CONTINUE
      WRITE(6,1592)
 1592 FORMAT(1X,'Channels energies computed')

C***Order channels by energy.

    4 CONTINUE
      ISWIT=0
      DO 5 I=2,NDIM
         IM1=I-1
         IF(EI(I).GE.EI(IM1))GOTO 5
         ISWIT=ISWIT+1
         ETM=EI(IM1)
         EI(IM1)=EI(I)
         EI(I)=ETM
        DO 6 J=1,NVIBX
           ITM=IS(IM1,J)
           IS(IM1,J)=IS(I,J)
    6   IS(I,J)=ITM
        DO 7 J=1,NANX
           ITM=JIN(IM1,J)
           JIN(IM1,J)=JIN(I,J)
    7   JIN(I,J)=ITM
         ITM=L(IM1)
         L(IM1)=L(I)
         L(I)=ITM
    5 CONTINUE
      IF(ISWIT.NE.0)GOTO 4

C***Assign IRWSPT, the row of the S matrix to print.
C***Assign irwneg.

      IRWNEG=1

C***The line below allows printing of more than
C***one row of the scattering matrix at intermediate distances.

      IF(IRWNEG.NE.0)IRWSPT=-IRWSPT
      DO 6501 I=1,NDIM
         IF(IS(I,1).EQ.0.AND.IS(I,2).EQ.0.AND.JIN(I,1).EQ.0.AND.
     1   JIN(I,2).EQ.0)IRWSPT=I
 6501 CONTINUE

C***Write out reordered channels.

      WRITE(6,8)
    8 FORMAT(1X,28HChannels reordered by energy)
      WRITE(6,44)(I,IS(I,1),IS(I,2),JIN(I,1),JIN(I,2),JIN(I,3),L(I),
     1I=1,NDIM)

C***Get potential expansion and calculate angular integrals.

      CALL SECOND(TIM1)
      TIME1=TIM1
      CALL ANGINT(IETA,JIN,L,NDIM,NUMT,IQ1,IQ2,IMU,B,IBMX,ID,NNUMT
     1,IS,ISYMU,JTOT,ISTM,ICOR,NQUADV,IVIBJ,RE,NUMF)
      CALL SECOND(TIM2)
      TIME2=TIM2
      PTIME(1)=PTIME(1)+TIME2-TIME1
      WRITE(6,9916)PTIME(1)
 9916 FORMAT(1X,15HTime in ANGINT ,1PE15.8)

C***Set asymptotic basis set.

      DO 37 I=1,NDIM
      DO 38 J=1,NDIM
   38    EFCN(J,I)=ZERO
   37    EFCN(I,I)=ONE
      RETURN
      ENTRY POT(R,NDIM,ID,B,UPCDMT)
      SR=R

C***Calculate quantites which depend on sector.

       NTVEC=NDIM*(NDIM+1)/2
       DO 71 IMN=1,NDIM
       DO 71 JMN=1,NDIM
          UPCDMT(JMN,IMN)=ZERO
   71  CONTINUE
      ISS=-NTVEC
      DO 73 M=1,NUMF
         XF=FUNC(SR,M)
         ISS=ISS+NTVEC
         IKFF=0
        DO 73 I=1,NDIM
        DO 73 J=1,I
           IKFF=IKFF+1
           UPCDMT(J,I)=UPCDMT(J,I)+XF*B(IKFF+ISS)
           UPCDMT(I,J)=UPCDMT(J,I)
   73 CONTINUE
      RETURN
      END

      SUBROUTINE HEADER
      SAVE 

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***This subroutine is called by SUBROUTINE PREPOT (Schwenke-Truhlar 3-D HF-HF
C***potential subroutine, in module 'stpot.f').

      WRITE(6,10)
      WRITE(15,10)
   10 FORMAT(/1X,46HSchwenke-Truhlar surface: Launay expansion of ,
     114Hthe potential./)
      RETURN
      END

      SUBROUTINE ANGINT(IETA,JIN,L,NDIM,NUMT,IQ1,IQ2,IMU,B,IBMX,ID,
     XNNUMT,IS,ISYMU,JTOT,IST,ICOR,NQUADV,IVIBJ,RE,NUMF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER FU2
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***This subroutine is called by SUBROUTINE PREPOT (Schwenke-Truhlar 3-D HF-HF
C***potential subroutine, in module 'stpot.f').
C***This subroutines reads the potential expansion coefficients
C***and calculates the angular integrals for the matrix elements.

      PARAMETER(FU2=2)
      INCLUDE 'parameter.inc'
      COMMON/JHOMCM/IHOM,JHOM
      DIMENSION JIN(IDX,NANX),L(IDX),IQ1(NNUMT),IQ2(NNUMT),IMU(NNUMT),
     1B(IBMX),IS(IDX,NVIBX)
      DATA ZERO,HALF,ONE/0.0D+0,0.5D+0,1.0D+0/
     1EPS/1.0D-10/
      JHOM=JIN(1,1)
      SRH=DSQRT(HALF)
      IBMXM=IBMX-10

C***Read in potential expansion indicies.

      READ(4,55)NUMT,NUMF
      READ(4,55)(IQ1(I),I=1,NUMT)
      READ(4,55)(IQ2(I),I=1,NUMT)
      READ(4,55)(IMU(I),I=1,NUMT)
   55 FORMAT(10I5)

C***Sort the expansion coefficients so that IQ1+IQ2 is in ascending order.

   90 CONTINUE
         ISW=0
         ISUM1=IQ1(1)+IQ2(1)
        DO 91 I1=2,NUMT
           ISUM2=IQ1(I1)+IQ2(I1)
           IF(ISUM2.GE.ISUM1)GOTO 91
           IM=I1-1
           IT=IQ1(IM)
           IQ1(IM)=IQ1(I1)
           IQ1(I1)=IT
           IT=IQ2(IM)
           IQ2(IM)=IQ2(I1)
           IQ2(I1)=IT
           IT=IMU(IM)
           IMU(IM)=IMU(I1)
           IMU(I1)=IT
           ISW=ISW+1
   91   ISUM1=ISUM2
      IF(ISW.GT.0)GOTO 90

C***Echo data.

      WRITE(6,48)NUMT,NUMF,(IQ1(I),IQ2(I),IMU(I),I=1,NUMT)
   48 FORMAT(/1X, 9HThere are,I5,18H angular terms and,I5,
     131H radial terms in the potential.,/12HThe angular ,
     235Hexpansion indicies are given below./(15X,3I5))

C***Calculate angular integrals over basis functions. Save only
C***non-zero entries.

      IF(ICOR.EQ.1)GOTO 50
      IF(ICOR.EQ.2)GOTO 51
         WRITE(6,52)ICOR
   52 FORMAT(1X,5HICOR=,I10)
      GOTO 50
   51 READ(2)IST
      READ(2)B
      WRITE(6,171)IST
  171 FORMAT(/1X,34HReading angular coefficients, IST=,I10)
      RETURN
   50 CONTINUE

C***Calculate "angular" integrals.  For the present form of the
C***potential, V = SUM VL(R,R1,R2) * Y (ANGLES),
C***VL(R,R1,R2)=SUM F(R) *VLF(R1,R2),
C***We can combine the angular and vibrational (R1,R2) integrals
C***into a single coefficient which is not zero.

      ISS=0
      NSIZE=NDIM*(NDIM+1)/2
      DO 69 I=1,NUMF
       DO 70 J=1,NSIZE
        B(J+ISS)=ZERO
   70  CONTINUE
       ISS=ISS+NSIZE
   69 CONTINUE
      IST=ISS

C***NAN is set equal numerically to NANX to prevent compiler
C***messages on certain machines.

      NAN=NANX
      IF(NAN.LT.13)STOP 'NANX too small in ANGINT in stpot.f'
                                                                        
C***Storage in JIN:
C***JIN(I,1) - J1.
C***JIN(I,2) - J2.
C***JIN(I,3) - J12.
C***JIN(I,4),JIN(I,5) - unique values of J1, no symmetry.
C***JIN(I,6),JIN(I,7) - unique values of J2, no symmetry.
C***JIN(I,8),JIN(I,9) - unique values of J12, no symmetry.
C***JIN(I,10),JIN(I,11) - unique values of L, no symmetry.
C***JIN(I,12) - pointer between states and unique states.
C***JIN(I,13) - pointer between interchanged states and unique states.
                                                                        
      CALL SBLOCK(JIN,L,ID,NDIM,JIN(1,4),JIN(1,10),IUN,JIN(1,12),
     1     JIN(1,13))
      IF(ISS+IUN*(IUN+1).GT.IBMX)
     1     STOP 'IBMX too small in ANGINT in stpot.f, increase NVIB1X'
      DO 71 I1=1,NUMT
       CALL CBLOCK(JIN(1,4),JIN(1,10),IUN,B(IST+1),ID,IQ1(I1),IQ2(I1),
     1             IMU(I1),JTOT,ISYMU)
       ISS=0
       DO 71 I2=1,NUMF
        DO 71 I3=1,NDIM
         DO 71 I4=1,I3
          CALL VIBINT(IS,JIN,ID,NQUADV,I3,I4,VIN1,VIN2,NDIM,IVIBJ,
     1                IQ1(I1),IQ2(I1),IMU(I1),I2,RE)
          IF(JIN(I3,12).GT.JIN(I4,12))THEN
           IADDR=(JIN(I3,12)*(JIN(I3,12)-1)/2)+JIN(I4,12)
          ELSE
           IADDR=(JIN(I4,12)*(JIN(I4,12)-1)/2)+JIN(I3,12)
          END IF
          IF(JIN(I3,13).GT.JIN(I4,12))THEN
           IADDRI=(JIN(I3,13)*(JIN(I3,13)-1)/2)+JIN(I4,12)
          ELSE
           IADDRI=(JIN(I4,12)*(JIN(I4,12)-1)/2)+JIN(I3,13)
          END IF
          TMP1=B(IST+IADDR)
          TMP2=B(IST+IADDRI)
          IF(MOD(IETA+JIN(I3,1)+JIN(I3,2)+JIN(I3,3)+L(I3),2).NE.0)
     1    TMP2=-TMP2
          ISS=ISS+1
          B(ISS)=B(ISS)+VIN1*TMP1+VIN2*TMP2
   71 CONTINUE
      ISS=0
      DO 72 I1=1,NDIM
       FACT=ONE
       IF(IS(I1,1).EQ.IS(I1,2).AND.JIN(I1,1).EQ.JIN(I1,2))FACT=SRH
       DO 72 I2=1,I1
        FACT1=FACT
        IF(IS(I2,1).EQ.IS(I2,2).AND.JIN(I2,1).EQ.JIN(I2,2))
     1    FACT1=FACT1*SRH
        ISS=ISS+1
        DO 72 I3=1,NUMF
         IADDR=ISS+(I3-1)*NSIZE
         B(IADDR)=B(IADDR)*FACT1
   72 CONTINUE
      IF(ICOR.EQ.0)RETURN
      OPEN(UNIT=FU2,FILE='fort.2',STATUS='UNKNOWN',FORM='UNFORMATTED')
      WRITE(2)IST
      WRITE(2)B
      CLOSE(UNIT=FU2)
      IF(ICOR.EQ.1)RETURN
      STOP
      END
