      SUBROUTINE SBLOCK(JIN,L,ID,NDIM,JINS,LS,IUN,INDX,INDXI)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER FU1
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***Extra routines for potential routine STPOT.
C***SBLOCK is called by SUBROUTINE ANGINT (Schwenke-Truhlar 3-D HF-HF 
C***potental subroutine, in module 'stpot.f').
C***Vibrating rotor diatom-diatom potential.
C***Given J,L channel indices, determine a set of channel indicies
C***which have no repeated pairs.

      PARAMETER(FU1=1)
      INCLUDE 'parameter.inc'
      DIMENSION JIN(IDX,NANX),L(IDX)
      DIMENSION JINS(IDX*2,3),LS(IDX*2),INDX(IDX),INDXI(IDX)
      IUN=0
      DO 1 I=1,NDIM
       IF(IUN.EQ.0)GO TO 2
        DO 3 J=1,IUN
         IF(JINS(J,1).EQ.JIN(I,1).AND.JINS(J,2).EQ.JIN(I,2).
     1      AND.JINS(J,3).EQ.JIN(I,3).AND.LS(J).EQ.L(I))THEN
          INDX(I)=J
          GO TO 1
         END IF
    3   CONTINUE
    2  IUN=IUN+1
       IF(IUN.GT.2*ID)THEN
        WRITE(6,53)IUN,IDX
   53   FORMAT(/1X,'In SBLOCK, number of unique J state pairs so far',
     1         ' is  ',I5,' but IDX = ',I5,
     2       /1X,'so dimensions would have been exceeded.')
        STOP 'IUNIQUE in SBLOCK in stpot2'
       END IF
       JINS(IUN,1)=JIN(I,1)
       JINS(IUN,2)=JIN(I,2)
       JINS(IUN,3)=JIN(I,3)
       LS(IUN)=L(I)
       INDX(I)=IUN
    1 CONTINUE
      DO 10 I=1,NDIM
       DO 13 J=1,IUN
        IF(JINS(J,1).EQ.JIN(I,2).AND.JINS(J,2).EQ.JIN(I,1).
     1      AND.JINS(J,3).EQ.JIN(I,3).AND.LS(J).EQ.L(I))THEN
         INDXI(I)=J
         GO TO 10
        END IF
   13  CONTINUE
       IUN=IUN+1
       IF(IUN.GT.2*ID)THEN
        WRITE(6,53)IUN,ID
        STOP 'IUNIQUE in SBLOCK in stpot2'
       END IF
       JINS(IUN,1)=JIN(I,2)
       JINS(IUN,2)=JIN(I,1)
       JINS(IUN,3)=JIN(I,3)
       LS(IUN)=L(I)
       INDXI(I)=IUN
   10 CONTINUE
      WRITE(6,4)IUN

C***Diagnostic write outs.

C     WRITE(6,5)(I,JINS(I,1),JINS(I,2),JINS(I,3),I=1,IUN)
C     WRITE(6,6)(I,INDX(I),INDXI(I),I=1,NDIM)
    4 FORMAT(/1X,30HNumber of unique JL channels =,I5)
C   5 FORMAT(1X,4I5)
C   6 FORMAT(1X,3I5)
      RETURN
      END
CC
      SUBROUTINE CBLOCK(JINS,LS,IUN,BLOCK,ID,IQ1,IQ2,IMU,JTOT,ISYMU)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER FU1
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***CBLOCK is called by SUBROUTINE ANGINT (Schwenke-Truhlar 3-D HF-HF 
C***potental subroutine, in module 'stpot.f').
C***Calculate angular integrals for this set of expansion
C***indicies for unique JL channels.

      PARAMETER(FU1=1)
      INCLUDE 'parameter.inc'
      DIMENSION JINS(IDX*2,3),LS(IDX*2),BLOCK(1)
      DATA ZERO/0.0D0/EPS/1.0D-10/
      IS=0
      DO 1 I=1,IUN
       J1=JINS(I,1)
       J2=JINS(I,2)
       J12=JINS(I,3)
       LI=LS(I)
       DO 1 J=1,I
        J1P=JINS(J,1)
        J2P=JINS(J,2)
        J12P=JINS(J,3)
        LF=LS(J)

C***Calculate integral between states.

        TMP1=ZERO
        IF(J2+J2P.LT.IQ2)GO TO 818
         IF(J1+J1P.LT.IQ1)GO TO 818
          IF(ABS(J2-J2P).GT.IQ2)GO TO 818
           IF(ABS(J1-J1P).GT.IQ1)GO TO 818
            IF(MOD(J2+J2P+IQ2,2).NE.0)GO TO 818
             IF(MOD(J1+J1P+IQ1,2).NE.0)GO TO 818

         IF (JTOT.EQ.ZERO) THEN

              MMAX=MIN0(J1,J2,J2P-IMU,J1P-IMU)
              MMIN=MAX0(-J1,-J2,-J2P-IMU,-J1P-IMU)
              IF(MMAX.LT.MMIN)GO TO 818
              TMP1=FCOEF5(J1,J2,J12,J1P,J2P,J12P,IQ1,IQ2,IMU,
     1                     MMAX,MMIN)

         ELSE IF (JTOT.NE.ZERO)THEN

               TMP1=FCOEF(J1,J2,J12,LI,J1P,J2P,J12P,LF,JTOT,IQ1,IQ2,IMU)

         END IF

  818   IF(ABS(TMP1).LE.EPS)TMP1=ZERO
        IS=IS+1
        BLOCK(IS)=TMP1
C       WRITE(6,9916)J1,J2,J12,J1P,J2P,J12P
C       WRITE(6,9915)I,J,IS,TMP1
C9916   FORMAT(1X,6I3)
C9915   FORMAT(1X,3I3,1P2E15.7)
    1 CONTINUE
      RETURN
      END
C
      SUBROUTINE VIBINT(IS,JIN,ID,NQUADV,INI,INF,VIN1,VIN2,NDIM,
     1IVIBJ,IQ1,IQ2,IMU,IFUNC,RE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER FU1
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***VIBINT is called by SUBROUTINE ANGINT (Schwenke-Truhlar 3-D HF-HF 
C***potental subroutine, in module 'stpot.f').
C***Calculate vibrational integral for the current expansion
C***coefficient for the the normal channel states and the
C***interchanged channel states.

      PARAMETER(FU1=1)
      INCLUDE 'parameter.inc'
      PARAMETER (MAXND=10,MAXJ=20,MAXV=8,MAXVS=MAXV*(MAXV+1)/2)
      DIMENSION XNODE(MAXND),WEIGHT(MAXND,MAXJ,MAXJ,MAXVS)
      DIMENSION POT(MAXND,MAXND),EIG(MAXV,MAXJ)
      DIMENSION IS(IDX,NVIBX),JIN(IDX,NANX)
      DATA IFIRST/0/
      IF(IFIRST.NE.0)GO TO 10

C***On first call, get vibrational weights, etc.
C***Create channel index for weights.

       MAXQN=0
       MJ=0
       DO 31 I=1,NDIM
        MJ=MAX0(JIN(I,1),JIN(I,2),MJ)
        MAXQN=MAX0(IS(I,1),IS(I,2),MAXQN)
   31  CONTINUE
       MAXQN=MAXQN+1
       MJ=MJ+1

C***Get weights and nodes.

       IF(IVIBJ.NE.0)MJ=1
       IF(MJ.GT.MAXJ.OR.MAXQN*(MAXQN+1)/2.GT.MAXVS)
     1 STOP 'Dimensions for weights in VIBINT in stpot2.f'
       IF(NQUADV.GT.MAXND)
     1 STOP 'NQUADV exceeds MAXND in VIBINT in stpot2.f'
       CALL WEIGH
       REWIND(UNIT=FU1)
       CALL WDATA(EIG,XNODE,WEIGHT,NQUADV,MJ,MAXQN,MAXV,MAXND
     1            ,MAXJ,1)
       IFIRST=1

C***Write out weights if desired.

C       DO 9158 I=1,MAXQN*(MAXQN+1)/2
C       DO 9158 J=1,MJ
C       WRITE(6,*)('I,J '),I,J
C       CALL PRNTM2(WEIGHT(1,1,J,I),NQUADV,MJ,MAXND)
C  9158 CONTINUE

       IQ1O=-1
       IQ2O=-1
       IMUO=-1
       IFUNCO=-1
   10 CONTINUE

C***Consider calculating potential expansion coefficients.

      IF(IQ1.EQ.IQ1O.AND.IQ2.EQ.IQ2O.AND.IMU.EQ.IMUO.AND.
     1   IFUNC.EQ.IFUNCO)GO TO 20
       DO 40 I=1,NQUADV
        X1=XNODE(I)+RE
        DO 40 J=1,NQUADV
         X2=XNODE(J)+RE
         CALL COEFJF(IFUNC,X1,X2,Y,POT(I,J),ND4,ND3,ND1,1,NQUDAG ,
     1               ND13,IQ1,IQ2,IMU)
   40  CONTINUE

C***More diagnostic print outs if desired.

C        WRITE(6,*)('IQ1, IQ2, IMU,IFUNC '),IQ1,IQ2,IMU,IFUNC
C        CALL PRNTM2(POT,NQUADV,NQUADV,MAXND)

       IQ1O=IQ1
       IQ2O=IQ2
       IMUO=IMU
       IFUNCO=IFUNC
   20 CONTINUE

C***Perform integrations.

      VIN1=0.0D0
      VIN2=0.0D0

C***IUSE1: 1st molecule.

      IF(IS(INF,1).GT.IS(INI,1))THEN
       IUSE1=(IS(INF,1)*(IS(INF,1)+1)/2)+IS(INI,1)+1
       K1=JIN(INF,1)+1
       K3=JIN(INI,1)+1
      ELSE
       IUSE1=(IS(INI,1)*(IS(INI,1)+1)/2)+IS(INF,1)+1
       K1=JIN(INI,1)+1
       K3=JIN(INF,1)+1
      END IF

C***IUSE2: 2nd molecule.

      IF(IS(INF,2).GT.IS(INI,2))THEN
       IUSE2=(IS(INF,2)*(IS(INF,2)+1)/2)+IS(INI,2)+1
       K2=JIN(INF,2)+1
       K4=JIN(INI,2)+1
      ELSE
       IUSE2=(IS(INI,2)*(IS(INI,2)+1)/2)+IS(INF,2)+1
       K2=JIN(INI,2)+1
       K4=JIN(INF,2)+1
      END IF

C***IUSE3: 1st molecule with quantum number of bra interchanged.

      IF(IS(INF,1).GT.IS(INI,2))THEN
       IUSE3=(IS(INF,1)*(IS(INF,1)+1)/2)+IS(INI,2)+1
       K1I=JIN(INF,1)+1
       K3I=JIN(INI,2)+1
      ELSE
       IUSE3=(IS(INI,2)*(IS(INI,2)+1)/2)+IS(INF,1)+1
       K1I=JIN(INI,2)+1
       K3I=JIN(INF,1)+1
      END IF

C***IUSE4: 2nd molecule with quantum number of bra interchanged.

      IF(IS(INF,2).GT.IS(INI,1))THEN
       IUSE4=(IS(INF,2)*(IS(INF,2)+1)/2)+IS(INI,1)+1
       K2I=JIN(INF,2)+1
       K4I=JIN(INI,1)+1
      ELSE
       IUSE4=(IS(INI,1)*(IS(INI,1)+1)/2)+IS(INF,2)+1
       K2I=JIN(INI,1)+1
       K4I=JIN(INF,2)+1
      END IF
      IF(IVIBJ.NE.0)THEN
       K1=1
       K2=1
       K3=1
       K4=1
       K1I=1
       K2I=1
       K3I=1
       K4I=1
      END IF
      DO 41 I=1,NQUADV
      TEMP1=0.0D0
      TEMP2=0.0D0
      DO 42 J=1,NQUADV
      TEMP1=TEMP1+WEIGHT(J,K1,K3,IUSE1)*POT(J,I)
      TEMP2=TEMP2+WEIGHT(J,K1I,K3I,IUSE3)*POT(J,I)
42    CONTINUE
      VIN1=VIN1+WEIGHT(I,K2,K4,IUSE2)*TEMP1
      VIN2=VIN2+WEIGHT(I,K2I,K4I,IUSE4)*TEMP2
41    CONTINUE
      RETURN
      END
