      SUBROUTINE POT(R,NDIM,ID,BPOT,UPCDMT)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C***This subroutine is for use with RMPROP: Version 2.1.2.
C***POT is called by PROGRAM RMPROP and by SUBROUTINE MATCH.
C***POT is only called by SUBROUTINE MATCH depending on input data.
C***This subroutine returns matrix elements of the potential matrix V
C***                                                                 ij  
C***betweeen simultaneous eigenfunctions of the channel orbital
C***angular momentum and of the separated subsystems
C***at the specified input value of the radial separation R.
C***The file 'parameter.inc' below gives parameters for those arrays
C***needed within RMPROP itself.
C***The common block JCM is also used to communicate with the potential
C***routine.

      INCLUDE 'parameter.inc'
      COMMON/JCM/JL(IDX),JTOTAL,IHOM,LAMMAX,LAMMIN
 
      DIMENSION UPCDMT(IDX,IDX),BPOT(IDX,IDX,NVIB1X),VL(NVIB1X)

C***Note that this form of the potential depends only upon the radial
C***separation of the centers-of-mass of the collision partners
C***the Percival-Seaton coefficients were calculated within
C***function FLAMB called within subroutine PREPOT.
C***Now calculate the coefficients of the Percival-Seaton coefficients.
C***Note that these extend from 1 to LAMMAX + 1 where LAMMAX was
C***read in by subroutine PREPOT.
C***These coefficients only depend upon the radial separation R, and
C***there should be no more than LAMMAX + 1 of them, where LAMMAX is
C***the upper limit on the expansion of the potential in LEGENDRE functions.

      LMAXP1=LAMMAX+1
      CALL FUN1(R,LMAXP1,VL)

C***Now multiply the appropriate Percival-Seaton terms together.
C***Note that the array containing the Percival-Seaton terms
C***has a first array index corresponding to unique channel pairs
C***and a second term corresponding to the number of terms in the
C***expansion of the interaction potential in Legendre functions.
C***The form of the DO-loops satisfies the triangle inequality between
C***the expansion coefficients and the internal angular momenta of 
C***the channels.

      DO 21 I=1,NDIM
         DO 21 JK=1,I
            LAMMX=MIN0(JL(I)+JL(JK),LAMMAX)                             5M16R94
            UPCDMT(JK,I)=0.0D0
            DO 21 LI=0,LAMMX,IHOM
               IIA=(LI/IHOM) +1                                         5M16R94
               UPCDMT(JK,I)=UPCDMT(JK,I)+BPOT(JK,I,IIA)*VL(IIA)         5M16R94
               UPCDMT(I,JK)=UPCDMT(JK,I)
21    CONTINUE
      RETURN
      END
