      SUBROUTINE ANGINT(IHOM,JIN,L,NDIM,NUMT,IMU,B,IBMX,ID
     1,ISJ,JTOT,IST,NNUMT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE

C***This subroutine is used by RMPROP: Version 2.1.2.
C***This subroutine is used for 3-D atom-diatom collisions.
C***This subroutine calculates the potential expansion coefficients
C***and analytically calculates the angular integrals for the matrix
C***elements.

      INCLUDE 'parameter.inc'
      LOGICAL LFIRST
      DIMENSION JIN(IDX,NANX),L(IDX),IMU(NNUMT),
     1B(IBMX),ISJ(IDX,NVIBX)
      EQUIVALENCE (ISTUFF,ASTFF2)
      DATA ZERO,HALF,ONE/0.0D+0,0.5D+0,1.0D+0/IFIRST,ICALC/2*0/
      DATA LFIRST/.FALSE./

C***Read in potential expansion indicies.

      READ(4,55)NUMT
      IF(IFIRST.NE.0)GOTO 9
      IFIRST=1
      I1=0
      DO 10 I=1,NUMT
      IMU(I)=I1
   10 I1=I1+IHOM
   55 FORMAT(I5)

C***Echo data to FORTRAN UNIT 6.

    9 CONTINUE
      WRITE(6,48)NUMT,(IMU(I),I=1,NUMT)
   48 FORMAT(/1X, 9HThere are,I5,73H terms in the potential expansion. T
     +he expansion indices are given below./(5X,24I5))

C***Calculate angular integrals over basis functions. Save only
C***non-zero entries.

      IST=1
      ISIG=-1
      ILAST=1
      IBMXM=IBMX-4
      DO 69 I=1,NDIM
      J1=JIN(I,1)
      LI=L(I)
      DO 69 J=1,I
      J1P=JIN(J,1)
      LF=L(J)
      ISIG=-ISIG
      DO 69 K=1,NUMT
      IF(IST.EQ.IBMXM)GOTO 100

      TMP1=FLAMB(J1,LI,J1P,LF,JTOT,IMU(K))

      IF(TMP1.EQ.ZERO)GOTO 70
      I1ST=K
      I2ND=2*ISIG
      ISTUFF=I1ST
      B(IST)=DBLE(I1ST)
      ILAST=IST
      IST=IST+1
      ISTUFF=I2ND
      B(IST)=DBLE(I2ND)
      B(IST+1)=TMP1
      IST=IST+2
      GOTO 69
   70 ASTFF2=B(ILAST)
      I1ST=IDINT(B(ILAST))
      ASTFF2=B(ILAST+1)
      I2ND=IDINT(B(ILAST+1))
      IV=I2ND
      IT=ISIGN(1,IV)
      IF(ISIG.EQ.IT)GOTO 69
      IF(K.NE.NUMT)GOTO 69
      I1ST=0
      I2ND=ISIG
      ISTUFF=I1ST
      B(IST)=DBLE(I1ST)
      IST=IST+1
      ISTUFF=I2ND
      B(IST)=DBLE(I2ND)
      ILAST=IST-1
      IST=IST+1
   69 CONTINUE
      I1ST=0
      I2ND=-ISIG
      ISTUFF=I1ST
      B(IST)=DBLE(I1ST)
      IST=IST+1
      ISTUFF=I2ND
      WRITE(6,71)IST
   71 FORMAT(/1X,I7,44H working precision words of bpot used in pot)
      LFIRST=.TRUE.
      RETURN
  100 WRITE(6,101)IBMX
  101 FORMAT(1X,37HDimensions exceeded in angint. IBMX =,I5)
      STOP
      END

      SUBROUTINE COEF(R,R1,Y,VLAM,ND1,ND4,NUMT,NQUAD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE

C***This subroutine is used by RMPROP: Version 2.1.2.
C***This subroutine calculates the expansion coefficients of an
C***arbitrary 3-D atom-diatom potential for an expansion in
C***Legendre functions.
C***Calculate the potential expansion coefficients at this value oF
C***R and R1.
C***
C***   Parameter List:
C***
C***R is the center-of-mass separation of the atom and diatom
C***
C***R1 is the bond length of the diatom (it will correspond to
C***a node of the vibrational quadrature).
C***
C***Y is an array containing the properly normalized and weighted
C***Legendre function at the node of the angular quadrature.
C***
C***VLAM(I1,I2) is an array which will contain the expansion coefficient
C***at the I1'th vibrational node for the I2'th angular term in the 
C***potential expansion.
C***
C***ND1 and ND4 are the dimensions of Y.
C***
C***NUMT is the number of terms in the angular expansion.
C***
      DIMENSION Y(ND1,ND4),VLAM(ND4)
      COMMON/APRJCM/NPTS,N1,N2,NPTSP,NFIND
      COMMON/PTIMCM/PTIME(10)
      DATA ZERO/0.0D+0/

C***First calculate potential at angular quadrature points

      CALL SECOND(TIME1)
      CALL FUN1(R,R1,Y(1,N1),Y(1,N2),NFIND)
      CALL SECOND(TIME2)
      IF(NFIND.EQ.NPTS)GOTO 4
      DO 5 I=1,NFIND
      J=NPTSP-I
    5 Y(J,N2)=Y(I,N2)
    4 CONTINUE

C***Project out coefficients

      DO 2 L=1,NUMT
    2 VLAM(L)=ZERO
      DO 3 L=1,NUMT
      DO 3 I=1,NPTS
      VLAM(L)=VLAM(L)+Y(I,N2)*Y(I,L)
    3 CONTINUE
      CALL SECOND(TIME3)
      PTIME(7)=PTIME(7)+TIME2-TIME1
      PTIME(8)=PTIME(8)+TIME3-TIME2
      RETURN
      END

      SUBROUTINE EXPGET(Y,ND1,ND4,NQUAD,IHOM,NUMT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C***
C***This subroutine is used by RMPROP: Version 2.1.2.
C***This subroutine supplies the quantities necessary for the
C***integrals projecting out the potential expansion
C***coefficients for expanding the interaction potential in Legendre
C***functions.
C***
C***   Parameter List:
C***
C***Y(I2,I1) on output contains the I1'th angular
C***function, times the appropriate weights and normalization
C***constants, evaluated at the I2'th angle.
C***
C***Y(I,N1) contains the cosine of the I'th angle.
C***
C***ND1 and ND4 are the 2 dimensions of Y.
C***
C***NQUAD is the order of quadrature,
C***
C***NUMT is the number of terms in the expansion of the potential.
C***
C***Note that ND1 > NUMT and that ND4 > NQUAD.
C***

C***MINIMUM DIMENSIONS
C***
C*** W(NQUAD)
C*** B(NQUAD)
C*** TEMP(2*NUMT)
C*** EP(2)

      DIMENSION Y(ND1,ND4),W(40),EP(2),B(40),TEMP(200)
      COMMON/APRJCM/NPTS,N1,N2,NPTSP,NFIND
      DATA ZERO,HALF/0.0D+0,0.5D+0/
      IF(NUMT.GT.100)GOTO 6
      IF(NQUAD.GT.40)GOTO 8
      IF(NQUAD.GT.ND1)GOTO 8
      N1=NUMT+1
      N2=N1+1
      NPTS=NQUAD
      NPTSP=NPTS+1
      NFIND=NPTS
      IF(IHOM.EQ.2.AND.MOD(NPTS,2).EQ.0)NFIND=NFIND/2
      IF(IHOM.EQ.2.AND.MOD(NPTS,2).NE.0)NFIND=(NFIND+1)/2

C***Perform Gauss-Legendre quadrature over the angles to find
C***the appropriate nodes

      CALL GAUSSQ(1,NQUAD,ZERO,ZERO,0,EP,B,Y(1,N1),W)

      LMX=IHOM*(NUMT-1)+1

C***Now evaluate Legendre functions at the nodes
C***and calculate the normalized angular functions with weights
C***for the expansion of the potential.

      DO 4 I1=1,NQUAD
         CALL LEG(TEMP,LMX,Y(I1,N1))
         I2=1
        DO 4 I=1,NUMT
           Y(I1,I)=TEMP(I2)*W(I1)*DBLE(2*I2-1)*HALF
    4 I2=I2+IHOM
      RETURN
    6 WRITE(6,7)NUMT
    7 FORMAT(/1X,28HIn EXPGET NUMT was too large,I5)
      STOP
    8 WRITE(6,9)NQUAD
    9 FORMAT(/1X,29HIn EXPGET NQUAD was too large,I5)
      STOP
      END

      SUBROUTINE HEADER
      WRITE(6,5)
    5 FORMAT(/1X,23HAtom-Diatom scattering./
     $1X,31HLegendre expansion of potential/)
      RETURN
      END
      SUBROUTINE POT(R,NDIM,ID,B,A)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C***
C***   Calculates potential interaction matrix for RMPROP: Version 2.1.2.
C***for arbitrary 3-D atom-diatom systems.
C***
C***   Parameter List: R, NDIM, ID, B, A
C***
C***R is the center-of-mass separation of the atom and diatom
C***
C***NDIM is the number of primitive basis functions in the close-coupling 
C***expansion
C***
C***ID is used to dimension many arrays and must be greater than or equal
C***to NDIM
C***
C***B is an array of dimension (IDX*IDX*NVIB1X) where IDX and NVIB1X
C***are set in parameter statements.  This array is used to hold
C***information concerning the (analytically determined) contribution
C***to the potential matrix elements from angular functions
C***
C***A is an output array used to hold on output the potential interaction
C***matrix for the given basis set and expansion of the potential at the
C***current value of R.
C***
C***   Minimum Dimensions:
C***
C*** XNODE(NQVMAX)
C*** WEIGHT(NQVMAX,MAXJJ,MAXJJ,MXV2)
C*** IMU(NUMBT)
C*** VLAM(NQVMAX,NUMBT)
C*** Y(NQAMAX,NUMBT+2)
C*** UA(NQAMAX)
C*** SA(NQAMAX)
C*** UB(NQAMAX)
C*** SB(NQAMAX)
C*** TEMP(NUMBT)
C***
C***NQAMAX order of angular quadrature
C***NQVMAX order of vibrational quadrature
C***NUMBT number of (independent) terms in the potential expansion
C***MAXV maximum vib. q.n. + 1
C***MAXJ maximum interal angular momemtum + 1
C***MXV2  MAXV*(MAXV+1)/2
C***MAXVV MAXV**2+MAXV
C*** 
      LOGICAL LVIBJ
      EQUIVALENCE (ISTUFF,ASTFF2) 
      INCLUDE 'parameter.inc'
      INCLUDE 'expand.inc'
      PARAMETER(MXV2=MAXV*(MAXV+1)/2)
      COMMON/LOGCM/LVIBJ
      COMMON/VCCM/Y(NQAMAX,NUMBT+2)
      COMMON/PRE1CM/RE,JTOT,NUMQ,NQUAD(10),NQUADA(10),RQUAD(10),MDIM
      COMMON/PRE2CM/XNODE(NQVMAX),WEIGHT(NQVMAX,MAXJJ,MAXJJ,MXV2),
     1ISJJ(IDX),JINN(IDX),MAXQN,NUMQSF,NUMT,
     1ISTM,IHOM,NV
      COMMON/PTIMCM/PTIME(10)

      DIMENSION VLAM(NQVMAX,NUMBT),TEMP(NUMBT)
      DIMENSION A(IDX,IDX),B(MDIM),VCOEF(NUMBT,MXV2),
     +EIGN(MAXV,MAXJJ)

      DATA ONE/1.0D+0/HALF/0.5D+0/FOUR/4.0D+0/
      DATA IFS/-1/ZERO/0.0D+0/

C***When IFIRST .ne. 1, the potential matrix elements at R are
C***calculated.

      SR=R

C***Calculate quantites which depend on sector.
C***Check to see if we should change order of quadrature or expansion
C***of potential.

      NUMQM1=NUMQ-1
      IF(NUMQSF.EQ.NUMQ.OR.ICALL.EQ.0)GOTO 43

C***Find the appropriate level of quadrature to be performed at this distance

      DO 87 I=1,NUMQM1
          IF(R-RQUAD(I).GE.1.0D-12)GO TO 87
         NEWQD=I
         GOTO 88
   87 CONTINUE

      NEWQD=NUMQ
   88 IF(NEWQD.EQ.NUMQSF)GOTO 43
      NUMQSF=NEWQD
      RQ=RQUAD(NUMQSF)
      NQUADV=NQUAD(NUMQSF)
      NQADAG=NQUADA(NUMQSF)

C***READ IN NEW NUMBER OF LEGENDRE FUNCTIONS IN WHICH THE INTERACTIONA
C***POTENTIAL IS EXPANDED AT THIS DISTANCE.

      READ(4,55)NUMT
   55 FORMAT(I5)
      WRITE(6,73)NUMT
   73 FORMAT(1X,31HThe potential expansion now has,I5,6H terms)

C***If the number of terms in the potential expansion has decreased,
C***throw out the elements of the array B corresponding to those
C***terms which are no longer used.

      CALL RESORT(B,ISTM,NUMT)

C***If the order of the vibrational quadratures has decreased, get
C***the weights and nodes for the new order of quadrature here.

      NV=MAXQN                                                          8M8R93
      CALL WDATA(EIGN,XNODE,WEIGHT,NQUADV,MJ,NV,MAXV,NQVMAX,MAXJJ,1)    6M2R94
      DO 76 I1=1,NQUADV
   76 XNODE(I1)=XNODE(I1)+RE

C***Calculate the functions for the current size of the angular
C***expansion of the potential at the current values of the
C***rotational quadrature nodes.

      CALL EXPGET(Y,NQAMAX,NUMBT+2,NQADAG,IHOM,NUMT)                    8M9R93
      WRITE(6,42)R,NQUADV,NQADAG
   42 FORMAT(/7H At R =,1PE15.8,10H switch to,I5,30H point quadrature fo
     +r vib. and,I5,34H point quad. for angular integrals/)

C***Calculate the expansion coefficients for the angular expansion
C***of the potential at the current vibrational quadrature points

   43 CONTINUE
      NQUADV=NQUAD(NUMQSF)
      NQADAG=NQUADA(NUMQSF)
      ICALL=1
      DO 39 I1=1,NQUADV
         CALL COEF(SR,XNODE(I1),Y,TEMP,NQAMAX,NUMBT+2,NUMT,NQADAG)      8M9R93
        DO 93 I3=1,NUMT
           VLAM(I1,I3)=TEMP(I3)
   93 CONTINUE
   39 CONTINUE

C***Diagnostic write out.

C     WRITE(6,511)(VLAM(1,K1),K1=1,NUMT)

C***If J independent vibrational states, perform vibrational integrals now.

      IF(LVIBJ)GOTO 98

      DO 97 I=1,MAXQN
         DO 97 J=1,MAXQN
            IF(J.GT.I)THEN
              IN1=J*(J-1)/2+I
            ELSE
              IN1=I*(I-1)/2+J
            END IF
           DO 97 K=1,NUMT
              VCOEF(K,IN1)=ZERO
                 DO 97 KI=1,NQUADV
      VCOEF(K,IN1)=VCOEF(K,IN1)+VLAM(KI,K)*WEIGHT(KI,1,1,IN1)
   97 CONTINUE
   98 CONTINUE
C     WRITE(6,*)('IN POT LVIBJ IS AFTER LINE 98 '),LVIBJ                8M9R93
  511 FORMAT(1X,1P,10E12.5)
      IST=1
      IISIGN=+1

C***Calculate potential matrix

      DO 40 I=1,NDIM
        DO 40 J=1,I
          IF(ISJJ(I).GT.ISJJ(J))THEN
             IUSE1=ISJJ(I)*(ISJJ(I)+1)/2+ISJJ(J)+1
             K1=JINN(I  )/IHOM + 1                                      8M9R93
             K3=JINN(J  )/IHOM + 1                                      8M9R93
          ELSE
             IUSE1=ISJJ(J)*(ISJJ(J)+1)/2+ISJJ(I)+1
             K1=JINN(J  )/IHOM + 1                                      8M9R93
             K3=JINN(I  )/IHOM + 1                                      8M9R93
         END IF
C***Check for non-zero angular coefficients, and integrate to get
C***only the necessary radial coefficients.

   70 SUM=ZERO
   35 ASTFF2=B(IST)

      I1ST=IDINT(B(IST))
      ASTFF2=B(IST+1)
      I2ND=IDINT(B(IST+1))
      ISIG=ISIGN(1,I2ND)
      IF(ISIG.NE.IISIGN)GOTO 47
      IV1=ABS(I2ND)
      IF(IV1.EQ.1)IST=IST+2                                             8M9R93
      IF(IV1.EQ.1)GOTO 47
      IST=IST+2
      VCO=ZERO
      IF(LVIBJ)GOTO 96
      VCO=VCOEF(I1ST,IUSE1)
      GOTO 72
   96 CONTINUE
      DO 46 I1=1,NQUADV

C***Diagnostic write out

C         WRITE(6,982)VLAM(I1,I1ST),WEIGHT(I1,K1,K3,IUSE1)

982      FORMAT(/,15HVLAM and WEIGHT,1X,1P,2E15.8)

   46 VCO=VCO+VLAM(I1,I1ST)*WEIGHT(I1,K1,K3,IUSE1)
   72 SUM=SUM+VCO*B(IST)
  981 FORMAT(1X,3I5,1P,3E15.8)
      IST=IST+1
      GOTO 35
   47 A(I,J)=SUM
      A(J,I)=SUM
40    IISIGN=-IISIGN
      RETURN
      END
      SUBROUTINE RESORT(B,ISTM,NUMT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C***
C***This subroutine used by RMPROP: Version 2.1.2.
C***This subroutine removes the entries in the array B which are no longer
C***needed because the number of terms in the potential expansion has
C***been reduced. 
C***
C***   Parameter List:
C***
C***B is an array containing the angular integrals of individual
C***Legendre functions in the expansion of the potential between
C***specific pairs of basis functions.  B also contains pointers
C***which allows the potential matrix routine to read and assign
C***these values to the correct basis functions and expansion
C***function unambiguously.
C***
C***ISTM is the current number of elements of B which are being used.
C***On return, ISTM will contain the new number of elements of B used.
C***
C***NUMT is new number of terms in the potential expansion on input.  
C***
C***In this program the matrix B represents non-zero Percival-Seaton
C***coefficients in the expansion of an atom-diatom potential.
C***The elements of B are in sets of three for each of the non-zero
C***coefficients: first there is an element for the index of the
C***coefficient (which term in the expansion), then an index for
C***the channel pair (I,J) of the potential matrix, then the
C***Percival-Seaton coefficient.
C***
      INCLUDE 'parameter.inc'
      DIMENSION B(IDX*IDX*NVIB1X)
      IST=1
      IISIGN=1
      ISTC=1
      NSAVE=0
      NTHROW=0
      NREP=0

C***1 is the loop over reading in entries

    1 CONTINUE

      I1ST=IDINT(B(IST)+0.1)                                            10M20R93
      ISIG=SIGN(1.D0,B(IST+1))                                          4M17R94
      I2ND=IDINT(B(IST+1)+ISIG*0.1)                                     10M20R93
      
C***Assign the elements of B to temporary variables prior to
C***saving or deleting them

      BS1=B(IST)
      BS2=B(IST+1)
      BS3=B(IST+2)

C***Test to see if the entry corresponds to an element which is
C***not in the new, smaller potential expansion. If it does,
C***go to line 3 and save the elements, and otherwise, delete the
C***elements.

      IF(I1ST.LE.NUMT) THEN                                             10M20R93
         IF(I1ST.EQ.0)THEN                                              10M20R93
C      Wwe have an IJ pair with no nonzero entries.                     10M20R93
C      There are only TWO elements of B associated with this pair       10M20R93
            B(ISTC)=BS1
            B(ISTC+1)=BS2
            IST=IST+2
            NSAVE=NSAVE+1
            ISTC=ISTC+2
         ELSE
C            We have a nonzero entry which needs to be saved
            B(ISTC)=BS1
            B(ISTC+1)=BS2
            B(ISTC+2)=BS3
            IST=IST+3
            NSAVE=NSAVE+1
            ISTC=ISTC+3
         ENDIF
C***Delete entries from list
      ELSE
         IF(IISIGN.EQ.ISIG)THEN
            IST=IST+3
            NTHROW=NTHROW+1
         ELSE
C***This is reached if this is a new channel pair.  None of the integrals will
C   be saved for this channel pair, because all are potential terms
C   with Lambda greater than NUMT.  Save this entry as a "placeholder" for the
C   IJ pair.
            
            NSAVE=NSAVE+1
            NREP=NREP+1
            B(ISTC)=0.D0
            B(ISTC+1)=ISIG
            IST=IST+3
            ISTC=ISTC+2
         ENDIF
      ENDIF
C             We've checked all possibilities for this term.
      IISIGN=ISIG
      IF(IST.LE.ISTM)GOTO 1
C
C            Now we're done.
      ISTM=ISTC-1
      WRITE(6,10)NSAVE,NTHROW,NREP
10    FORMAT(1X,'In RESORT ',I5,' entries were saved'/I5,' entries we',
     & 're thrown out, and ',I5,' entries were replaced.')
      RETURN
      END
