      SUBROUTINE POT(R,NDIM,ID,B,UPCDMT)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      INCLUDE 'parameter.inc'
      INCLUDE 'expand.inc'

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***POT is called by PROGRAM RMPROP and by SUBROUTINE MATCH.
C***POT is only called by SUBROUTINE MATCH depending on input data.
C***This subroutine calculates matrix elements for Launay angular functions
C***between asymptotic basis functions.
      PARAMETER(MXV2=MAXV*(MAXV+1)/2)                                   6M3R94
      DIMENSION UPCDMT(IDX,IDX),B(IDX*IDX*NVIB1X)
      COMMON/PRPTCM/JTOT,NUMQ,NQUAD(10),NQUADA(10),RQUAD(10),RE
      COMMON/PRE2CM/INDEX(MXV2),ISJ(IDX,2),JINJ(IDX,3),LJ(IDX),         6M3R94
     1IQ1(NUMBT),IQ2(NUMBT),IMU(NUMBT)
      COMMON/PRE3CM/EIJ(IDX),RQ,XNODE(NQVMAX),
     1              WEIGHT(NQVMAX,MAXJJ,MAXJJ,MXV2),WV1(NQVMAX**2),     6M3R94
     1              WV2(NQVMAX**2)
      COMMON/TEMPCM/TEMPAR(IDX,IDX)
      COMMON/PRE4CM/NUMQSF,IETA,ISTM,IVIBJ,ISYMU,ICALC,ICALL,MJ,MAXQN,
     1              NUMT,NQADAG,NQUADV,NSQ,IW1(NQVMAX**2),
     2              IW2(NQVMAX**2)
      COMMON/VCCM/Y(NQAMAX**3,NUMBT+25)
      COMMON/PTIMCM/PTIME(10)
      COMMON/JHOMCM/IHOM,JHOM                                           6M8R94
      DIMENSION VLAM(NQVMAX**2,NUMBT)
      DIMENSION UA(NQAMAX),SA(NQAMAX),UB(NQAMAX),SB(NQAMAX),TEMP(NUMBT)
      DATA ONE/1.0D+0/HALF/0.5D+0/FOUR/4.0D+0/
      DATA IFS/-1/ZERO/0.0D+0/

      CALL SECOND(TIMEA)
      IBMX=IDX*IDX*NVIB1X

C***Calculate quantities which depend on sector.

C***Check to see if we should change order of quadrature or size of expansion
C***of potential in Launay functions.

      IF(NUMQSF.GE.NUMQ.OR.((RQ-R).GT.1.0D-12).OR.ICALL.EQ.1)GOTO 43
      ICALL=ICALL+1
      NUMQSF=NUMQSF+1
      RQ=RQUAD(NUMQSF)
      NQUADV=NQUAD(NUMQSF)
      NQADAG=NQUADA(NUMQSF)
      CALL SECOND(TIME1)
      READ(4,55)NUMT
      WRITE(6,73)R,NUMT                                                 6M3R94
   55 FORMAT(10I5)
      CALL RESORT(B,ISTM,NUMT,TEMPAR,IBMX)
   73 FORMAT(/,1X,'At R= ',F10.6,' the potential expansion now has',    6M3R94
     & I5,' terms')                                                     6M3R94
      CALL SECOND(TIME2)
      NWD1=NQVMAX                                                       8M5R93
      NWD2=MAXJJ                                                        8M5R93
      CALL WDATA(TEMPAR,XNODE,WEIGHT,NQUADV,MJ,MAXQN,IDX,NWD1,NWD2,1)   4M12R94
      CALL SECOND(TIME3)
      CALL EXPGET(Y,UA,SA,UB,SB,NQADAG,IQ1,IQ2,IMU,NUMT)
      CALL SECOND(TIME4)
      PTIME(1)=PTIME(1)+TIME2-TIME1
      PTIME(2)=PTIME(2)+TIME4-TIME3
      PTIME(3)=PTIME(3)+TIME3-TIME2
      IPOS=1
      DO 60 I=1,NQUADV
      DO 60 J=1,NQUADV
      IW1(IPOS)=I
      IW2(IPOS)=J
   60 IPOS=IPOS+1
      NSQ=IPOS-1
      WRITE(6,42)R,NQUADV,NQADAG
   42 FORMAT(/7HAt R = ,1PE15.8,10H switch to,I5,30H point quadrature fo
     +r vib. and,I5,34H point quad. for angular integrals/)

C***Calculate expansion coefficents at quadrature points.

   43 CALL SECOND(TIME1)
      ICALL=2
      INX=1
      DO 39 I1=1,NQUADV
      X1=XNODE(I1)+RE
      DO 39 I2=1,NQUADV
      X2=XNODE(I2)+RE
      CALL COEF(R,X1,X2,Y,TEMP,NUMT,NQADAG)
      DO 93 I3=1,NUMT
      VLAM(INX,I3)=TEMP(I3)
   93 CONTINUE
      INX=INX+1
   39 CONTINUE
      CALL SECOND(TIME2)
      PTIME(4)=PTIME(4)+TIME2-TIME1

C***Diagnostic write out.

C     WRITE(6,51)(VLAM(1,K1),K1=1,NUMT)
   51 FORMAT(1X,1P,10E12.5)
      IST=1
      ISIGN=+1
      CALL SECOND(TIME1)

C***Calculate potential matrix.  Note that the lines commented out with "CC"
C***through the next note are incorrect; they are retained in commented form
C***to allow comparison with old runs

      DO 40 I=1,NDIM

C***Old lines begin here.

CC    IS1=ISJ(I,1)
CC    IS2=ISJ(I,2)
CC    IJ1=IS1+1
CC    IJ2=IS2+1
CC    K1=JINJ(I,1)+1
CC    K2=JINJ(I,2)+1
CC    IF(IVIBJ.NE.0)K1=1
CC    IF(IVIBJ.NE.0)K2=1
      DO 40 J=1,I
CC    J1=ISJ(J,1)
CC    J2=ISJ(J,2)
CC    K3=JINJ(J,1)+1
CC    K4=JINJ(J,2)+1
CC    IF(IVIBJ.NE.0)K3=1
CC    IF(IVIBJ.NE.0)K4=1
CC    IJ3=J1*MAXQN
CC    IJ4=J2*MAXQN
CC    IJ5=IJ3+IJ1
CC    IJ6=IJ4+IJ2
CC    IJ7=IJ4+IJ1
CC    IJ8=IJ3+IJ2
CC    IUSE1=INDEX(IJ5)
CC    IUSE2=INDEX(IJ6)
CC    IUSE3=INDEX(IJ7)
CC    IUSE4=INDEX(IJ8)
C***'Old' Lines end here.

C***New definition of IUSE etc was introduced 11/16/86. The old
C***definition was in error when IS(I,K) < IS(J,K), K=1,2.
C***These lines are those above commented out with 'CC'; they are
C***kept for 'historical interest', i. e., comparison to existing
C***old output.
C***New lines begin here.

C***IUSE1: WEIGHTS FOR THE FIRST MOLECULE

       IF(ISJ(I,1).GE.ISJ(J,1))THEN
        IUSE1=(ISJ(I,1)*(ISJ(I,1)+1)/2)+ISJ(J,1)+1
        IUSE1=(ISJ(I,1)*(ISJ(I,1)+1)/2)+ISJ(J,1)+1
        K1=JINJ(I,1)/IHOM+1                                             6M8R94
        K3=JINJ(J,1)/IHOM+1                                             6M8R94
       ELSE
        IUSE1=(ISJ(J,1)*(ISJ(J,1)+1)/2)+ISJ(I,1)+1
        K1=JINJ(J,1)/IHOM+1                                             6M8R94
        K3=JINJ(I,1)/IHOM+1                                             6M8R94
       END IF
 
C***IUSE2: WEIGHTS FOR THE SECOND MOLECULE.

       IF(ISJ(I,2).GE.ISJ(J,2))THEN
        IUSE2=(ISJ(I,2)*(ISJ(I,2)+1)/2)+ISJ(J,2)+1
        K2=JINJ(I,2)/IHOM+1                                             6M8R94
        K4=JINJ(J,2)/IHOM+1                                             6M8R94
       ELSE
        IUSE2=(ISJ(J,2)*(ISJ(J,2)+1)/2)+ISJ(I,2)+1
        K2=JINJ(J,2)/IHOM+1                                             6M8R94
        K4=JINJ(I,2)/IHOM+1                                             6M8R94
       END IF
 
C***IUSE3: WEIGHTS FOR THE FIRST MOLECULE WITH Q.N. OF KET INTERCHANGED

       IF(ISJ(I,1).GE.ISJ(J,2))THEN
        IUSE3=(ISJ(I,1)*(ISJ(I,1)+1)/2)+ISJ(J,2)+1
        K1I=JINJ(I,1)/IHOM+1                                            6M8R94
        K3I=JINJ(J,2)/IHOM+1                                            6M8R94
       ELSE
        IUSE3=(ISJ(J,2)*(ISJ(J,2)+1)/2)+ISJ(I,1)+1
        K1I=JINJ(J,2)/IHOM+1                                            6M8R94
        K3I=JINJ(I,1)/IHOM+1                                            6M8R94
       END IF
 
C***IUSE4: WEIGHTS FOR THE SECOND MOLECULE WITH Q.N. OF KET INTERCHANGED

       IF(ISJ(I,2).GE.ISJ(J,1))THEN
        IUSE4=(ISJ(I,2)*(ISJ(I,2)+1)/2)+ISJ(J,1)+1
        K2I=JINJ(I,2)/IHOM+1                                            6M8R94
        K4I=JINJ(J,1)/IHOM+1                                            6M8R94
       ELSE
        IUSE4=(ISJ(J,1)*(ISJ(J,1)+1)/2)+ISJ(I,2)+1
        K2I=JINJ(J,1)/IHOM+1                                            6M8R94
        K4I=JINJ(I,2)/IHOM+1                                            6M8R94
       END IF
       IF(IVIBJ.NE.0)THEN
        K1=1
        K2=1
        K3=1
        K4=1
        K1I=1
        K2I=1
        K3I=1
        K4I=1
       END IF

C***New lines end here.
      DO 61 I1=1,NSQ
      WV1(I1)=WEIGHT(IW2(I1),K2,K4,IUSE2)*WEIGHT(IW1(I1),K1,K3,IUSE1)
C      WV2(I1)=WEIGHT(IW2(I1),K2,K3,IUSE4)*WEIGHT(IW1(I1),K1,K4,IUSE3)  8M3R93
      WV2(I1)=WEIGHT(IW2(I1),K2I,K4I,IUSE4)*                            8M3R93
     & WEIGHT(IW1(I1),K1I,K3I,IUSE3)                                    8M3R93
61    CONTINUE

C***Check for non-zero angular coefficients, and integrate to get
C***only the necessary radial coefficients.

70    SUM=ZERO
C                Get angular integrals from B:                          8M5R93
C                 for each IJ basis function pair, the nonzero          8M5R93
C                 <IJ|VLAM|IpJp> and <JI|VLAM|IpJp> are stored          8M5R93
C                 check sign: if different we're on a new IJ pair       8M5R93
C                                                                       8M5R93
35    IV=INT(B(IST)) 
      ISIG=SIGN(1,IV)
      IF(ISIG.NE.ISIGN)GOTO 47
C                                                                       8M5R93
C               take int(abs(b(ist))) =                                 8M5R93
C                 IV =  IV1*1000 + IV2                                  8M5R93
C                 where IV2 is the index of the angular term            8M5R93
C                                                                       8M5R93
C                 where IV1 is 1 for no nonzero integrals               8M5R93
C                              2 if only interchanged is nonzero        8M5R93
C                                next B is ang. integral                8M5R93
C                              3 if only non-interchanged nonzero       8M5R93
C                                next B is ang. integral                8M5R93
C                              4 if both are nonzero                    8M5R93
C                                next B nonint. ang. integral,          8M5R93
C                                B after is int. ang. integral          8M5R93
C                                                                       8M5R93
      IV=INT(ABS(B(IST)))
      IST=IST+1  
      IV1=IV/1000
      IF(IV1.EQ.1)GOTO 47
      IV2=IV-1000*IV1
C                                                                       8M5R93
C                 Do non-interchanged integral                          8M5R93
C                                                                       8M5R93
      IF(IV1.GT.2)THEN                                                  8M5R93
         VCO=ZERO
         CALL SECOND(TIME2)
         DO 46 I1=1,NSQ                                                 8M5R93
            VCO=VCO+WV1(I1)*VLAM(I1,IV2)                                8M5R93
46       CONTINUE                                                       8M5R93
         CALL SECOND(TIME3)
         PTIME(5)=PTIME(5)+TIME3-TIME2
         SUM=SUM+VCO*B(IST)
         IST=IST+1
      ENDIF                                                             8M5R93
C                                                                       8M5R93
C                  Do interchanged integral                             8M5R93
C                                                                       8M5R93
      IF(IV1.NE.3)THEN                                                  8M5R93
         VCO=ZERO
         CALL SECOND(TIME2)
         DO 85 I1=1,NSQ                                                 8M5R93
            VCO=VCO+WV2(I1)*VLAM(I1,IV2)                                8M5R93
85       CONTINUE                                                       8M5R93
         CALL SECOND(TIME3)
         PTIME(5)=PTIME(5)+TIME3-TIME2
         SUM=SUM+VCO*B(IST)
         IST=IST+1
      ENDIF                                                             8M5R93
C
C                  Go back to check the next entry of B
      GOTO 35
C                                                                       8M5R93
C                  Fill in IJ'th matrix element                         8M5R93
C                                                                       8M5R93
47    UPCDMT(I,J)=SUM
      UPCDMT(J,I)=SUM
C                                                                       8M5R93
C                  Change sign for next IJ pair                         8M5R93
C                                                                       8M5R93
      ISIGN=-ISIGN                                                      8M5R93
C                                                                       8M5R93
C                                                                       8M5R93
40    CONTINUE                                                          8M5R93
      CALL SECOND(TIME2)
      PTIME(6)=PTIME(6)+TIME2-TIME1
      RETURN
      END
      SUBROUTINE EXPGET(Y,UA,SA,UB,SB,NQUAD,IQ1,IQ2,IMU,
     1NUMT)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'expand.inc'

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***EXPGET is called by SUBROUTINE POT (general 3-D diatom-diatom potential
C***routine, in module 'vgr3.f').
C***This subroutine supplies the quantities necessary for the integrals
C***projecting out the Launay potential expansion coefficients.
C***
C***Parameter List:
C***
C***Y(I2,I1) on output contains the I1'th Launay angular function times the
C***appropriate weights and normalization constants evaluated at the
C***I2'th THETA1, THETA2 and PHI2-PHI1.
C***
C***UA(I) contains the cosine of the I'th THETA.
C***
C***SA(I) contains the sine of the I'th THETA.
C***
C***UB(I) contains the cosine of the I'th PHI2-PHI1.
C***
C***SB(I) contains the sine of the I'th PHI2-PHI1.
C***
C***UA,SA,UB and SB are output arrays.
C***
C***IQ1,IQ2 and IMU are the potential expansion indices.
C***
C***NUMT is the number of terms in the expansion.
C***
C====Minimum Dimensions:
C***
C*** W(NQAMAX)
C*** BB(NQAMAX)
C*** X3(NQAMAX)
C*** W3(NQAMAX)
C*** TEMP(NUMBT)
C*** EP(2)
C*** Y(NQAMAX**3,NUMBT+25)
C*** IQ1(NUMBT)
C*** IQ2(NUMBT)
C*** IMU(NUMBT)
C*** UA(NQAMAX)
C*** SA(NQAMAX)
C*** UB(NQAMAX)
C*** SB(NQAMAX)
C*** UA(NQAMAX)

      DIMENSION IQ1(NUMBT),IQ2(NUMBT),IMU(NUMBT)
      DIMENSION Y(NQAMAX**3,NUMBT+25),UA(NQAMAX),W(NQAMAX),EP(2),
     1BB(NQAMAX),X3(NQAMAX),W3(NQAMAX),UB(NQAMAX),SA(NQAMAX),SB(NQAMAX),
     1TEMP(NUMBT)
      COMMON/APRJCM/NPTS,N1,N2,N3,N4,N5,N6,N7
      DATA ZERO,ONE,EIGHT/0.0D+0,1.0D+0,8.0D+0/TWO/2.0D+0/
      IF(NUMT.GT.999)GOTO 6
C***line below changed by mju2-22-93
C     IF(NQUAD.GT.15)GOTO 8
      IF(NQUAD.GT.NQAMAX)GOTO 8
C***LINE BELOW CHANGED BY MJU12-29-92
C     IF(NQUAD**3.GT.ND13)GOTO 8
      IF(NQUAD**3.GT.NQAMAX**3)GOTO 8
      PI=ACOS(-ONE)
      FPI=ONE/(EIGHT*PI)
      CALL GAUSSQ(1,NQUAD,ZERO,ZERO,0,EP,BB,UA,W)
      CALL GAUSSQ(2,NQUAD,ZERO,ZERO,0,EP,BB,UB,W3)
      LMX=0
      DO 1 I=1,NUMT
    1 LMX=MAX0(LMX,IQ1(I),IQ2(I))
      LMX=LMX+1
      DO 3 I=1,NQUAD
      X3(I)=ACOS(UB(I))
    3 CONTINUE
      IACNT=0
      DO 4 I1=1,NQUAD
      DO 4 I2=1,NQUAD
      DO 4 I3=1,NQUAD
      IACNT=IACNT+1
      CALL YQQM(TEMP,UA(I1),UA(I2),X3(I3),LMX,IQ1,IQ2,IMU,NUMT)
      DO 4 I=1,NUMT
      Y(IACNT,I)=TEMP(I)*W(I1)*W(I2)*W3(I3)*FPI*TWO
    4 CONTINUE
      DO 5 I=1,NQUAD
      SA(I)=SQRT(ONE-UA(I)**2)
    5 SB(I)=SQRT(ONE-UB(I)**2)

C***Fill vectors with sines/cosines of angles that are the nodes of angular
C***quadratures.

      IACNT=0
      N1=NUMT+1
      N2=N1+1
      N3=N2+1
      N4=N3+1
      N5=N4+1
      N6=N5+1
      N7=N6+1
      DO 10 I1=1,NQUAD
      DO 10 I2=1,NQUAD
      DO 10 I3=1,NQUAD
      IACNT=IACNT+1
      Y(IACNT,N1)=UA(I1)
      Y(IACNT,N2)=SA(I1)
      Y(IACNT,N3)=UA(I2)
      Y(IACNT,N4)=SA(I2)
      Y(IACNT,N5)=UB(I3)
   10 Y(IACNT,N6)=SB(I3)
      NPTS=IACNT
      RETURN
    6 WRITE(6,7)NUMT
    7 FORMAT(/1X,28HIn EXPGET NUMT was too large,I5)
      STOP 'In module vgr3.f'
    8 WRITE(6,9)NQUAD
    9 FORMAT(/1X,29HIn EXPGET NQUAD was too large,I5)
      STOP 'In module vgr3.f'
      END   
      SUBROUTINE COEF(R,R1,R2,Y,TEMP,NUMT,NQUAD)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      INCLUDE 'expand.inc'

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***COEF is called by SUBROUTINE POT (general 3-D diatom-diatom potential
C***routine, in module 'vgr3.f').
C***Calculate the potential expansion coefficients at this value of
C***R, R1 and R2.
C***   Parameter List:
C***
C***R is the center-of-mass separation of the diatoms.
C***
C***R1 is the bond length of the first monomer.
C***
C***R2 is the bond length of the second monomer.
C***
C***Y contains in row 1 through NQUAD**3 and columns N1 and N2 the cosine and
C***the sine of the values of THETA1 used in the angular quadrature for THETA1.
C***
C***Y contains in row 1 through NQUAD**3 and columns N3 and N4 the cosine and
C***the sine of the values of THETA2 used in the angular quadrature for THETA2.
C***
C***Y contains in row 1 through NQUAD**3 and columns N1 and N2 the cosine and
C***the sine of the values of (PHI2-PHI1) used in the angular quadrature for
C***(PHI2-PHI1).
C***
C***TEMP(I) contains on output the expansion coefficient of the I'th
C***Launay coefficient at this value of R, R1, and R2.
C***
C***NUMT is the current number of terms in the Launay expansion.a
C***
C***NQUAD is the current order of the angular quadratures.
C***
      DIMENSION Y(NQAMAX**3,NUMBT+25),TEMP(NUMBT)
      COMMON/APRJCM/NPTS,N1,N2,N3,N4,N5,N6,N7
      COMMON/PTIMCM/PTIME(10)
      DATA ZERO/0.0D+0/
      IF(NQUAD.GT.15)GOTO 4

C***First calculate interaction potential at angular quadrature points.

      CALL SECOND(TIME1)
      CALL FUN1(R,R1,R2,Y(1,N1),Y(1,N2),Y(1,N3),Y(1,N4),Y(1,N5),Y(1,N6),
     $Y(1,N7),NPTS)
      CALL SECOND(TIME2)

C***Now project out coefficents of expansion in Launay angular functions.

      DO 2 L=1,NUMT
    2 TEMP(L)=ZERO
      DO 3 L=1,NUMT
      DO 3 M=1,NPTS
       TEMP(L)=TEMP(L)+Y(M,N7)*Y(M,L)
    3 CONTINUE
      CALL SECOND(TIME3)
      PTIME(7)=PTIME(7)+TIME2-TIME1
      PTIME(8)=PTIME(8)+TIME3-TIME2
      RETURN
    4 WRITE(6,5)NQUAD
    5 FORMAT(/1X,28HIn COEF, NQUAD was too large,I5)
      STOP 'In module vgr3.f'
      END
      SUBROUTINE ANGINT(IETA,JIN,L,NDIM,NUMT,IQ1,IQ2,IMU,B,IBMX,ID
     +,NNUMT,IS,ISYMU,JTOT,IST,ICALC)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      INCLUDE 'parameter.inc'
      INCLUDE 'expand.inc'

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***This subroutine reads the indices for the Launay functions used
C***to expand the potential.  
C***This program calculates the angular integrals for the matrix elements
C*** and may also read/write a file containing
C***the angular integrals for the matrix elements.
      PARAMETER(MXV2=MAXV*(MAXV+1)/2)                                   6M3R94
      COMMON/PRE3CM/EIJ(IDX),RQ,XNODE(NQVMAX),
     1              WEIGHT(NQVMAX,MAXJJ,MAXJJ,MXV2),WV1(NQVMAX**2),     6M3R94
     1              WV2(NQVMAX**2)
      COMMON/TEMPCM/TEMPAR(IDX,IDX)
      LOGICAL LFIRST
      DIMENSION JIN(IDX,NANX),L(IDX),IQ1(NUMBT),IQ2(NUMBT),IMU(NUMBT),
     +B(IDX*IDX*NVIB1X),IS(IDX,NVIBX)
      DATA ZERO,HALF,ONE/0.0D+0,0.5D+0,1.0D+0/IFIRST/0/EPS/1.0D-10/     8M2R93
      DATA LFIRST/.FALSE./
      SRH=SQRT(HALF)

C***Read in potential expansion indices.

      READ(4,55)NUMT
      IF(IFIRST.NE.0)GOTO 9
      IFIRST=1
      READ(4,55)(IQ1(I),I=1,NUMT)
      READ(4,55)(IQ2(I),I=1,NUMT)
      READ(4,55)(IMU(I),I=1,NUMT)
   55 FORMAT(10I5)

C***Sort expansion indices in increasing order of IQ1+IQ2.
C***This is necessary since RESORT will assume that when the number
C***of terms is reduced, the new indices will all be before the
C***indices which are eliminated.

   50 CONTINUE
      ISWTCH=0
      I1=IQ1(1)+IQ2(1)
      IM=1
      DO 51 I=2,NUMT
      I2=IQ1(I)+IQ2(I)
      IF(I1.LE.I2)GOTO 52
      ISWTCH=ISWTCH+1
      I1=IQ1(I)
      IQ1(I)=IQ1(IM)
      IQ1(IM)=I1
      I1=IQ2(I)
      IQ2(I)=IQ2(IM)
      IQ2(IM)=I1
      I1=IMU(I)
      IMU(I)=IMU(IM)
      IMU(IM)=I1
   52 I1=I2
   51 IM=I
      IF(ISWTCH.NE.0)GOTO 50

C***Echo data.

    9 CONTINUE
      WRITE(6,48)NUMT,(IQ1(I),IQ2(I),IMU(I),I=1,NUMT)
   48 FORMAT(/1X, 9HThere are,I5,73H terms in the potential expansion. T
     +he expansion indices are given below./(15X,3I5))

C***Calculate angular integrals over basis functions.  Save only
C***non-zero entries.

      IF(ICALC.NE.2)GOTO 20
      REWIND 2
      READ(2)IST,IWRIT,IBMXX
      IF(IBMXX.EQ.IBMX)GOTO 120
      WRITE(6,119)IBMXX,IBMX
  119 FORMAT(1X,44HIn ANGINT, the dimensions have changed IBMXX,I9
     $,5H IBMX,I9)
      STOP 'In module vgr3.f'
  120 CONTINUE
      READ(2)B
      WRITE(6,71)IST,ICALC
      RETURN
   20 CONTINUE
      IST=1
  915 FORMAT(1X,6HANGINT)
      IWRIT=0
      ISIG=-1
      EPSS=-0.001D+0
      IBMXM1=IBMX-1
      ILAST=1
      DO 69 I=1,NDIM
      J1=JIN(I,1)
      J2=JIN(I,2)
      J12=JIN(I,3)
      LI=L(I)
      IPAR=J1+J2+LI+IETA
      FACT=ONE
      IF(ISYMU.EQ.0.AND.J1.EQ.J2.AND.IS(I,1).EQ.IS(I,2))FACT=SRH
      DO 69 J=1,I
      J1P=JIN(J,1)
      J2P=JIN(J,2)
      J12P=JIN(J,3)
      LF=L(J)
  917 FORMAT(1X,7HANGINT ,2I5)
      FACT1=FACT
      IF(ISYMU.EQ.0.AND.J1P.EQ.J2P.AND.IS(J,1).EQ.IS(J,2))
     +FACT1=FACT1*SRH
      ISIG=-ISIG
      EPSS=-EPSS
      DO 69 K=1,NUMT
       IF(JTOT.NE.ZERO)THEN

      TMP1=FCOEF(J1,J2,J12,LI,J1P,J2P,J12P,LF,JTOT,IQ1(K),IQ2(K),IMU(K))
      IF(ABS(TMP1).LT.EPS)TMP1=ZERO
      TMP2=ZERO
      IF(ISYMU.EQ.0)TMP2=
     +FCOEF(J1,J2,J12,LI,J2P,J1P,J12P,LF,JTOT,IQ1(K),IQ2(K),IMU(K))
      IF(ABS(TMP2).LT.EPS)TMP2=ZERO

       ELSE IF (JTOT.EQ.ZERO)THEN
       TMP1=ZERO
       IF(J2+J2P.LT.IQ2(K))GOTO 818
       IF(J1+J1P.LT.IQ1(K))GOTO 818                                     8M30R94
       IF(ABS(J2-J2P).GT.IQ2(K))GOTO 818
       IF(ABS(J1-J1P).GT.IQ1(K))GOTO 818                                8M30R94
       IF(MOD(J2+J2P+IQ2(K),2).NE.0)GOTO 818 
       IF(MOD(J1+J1P+IQ1(K),2).NE.0)GOTO 818
       MMAX=MIN0(J1,J2,J2P-IMU(K),J1P-IMU(K))
       MMIN=MAX0(-J1,-J2,-J2P-IMU(K),-J1P-IMU(K))
       IF(MMAX.LT.MMIN)GOTO 818
      TMP1=FCOEF5(J1,J2,J12,J1P,J2P,J12P,IQ1(K),IQ2(K),IMU(K),MMAX,MMIN)
  818 IF(ABS(TMP1).LE.EPS)TMP1=ZERO
       TMP2=ZERO
       IF(ISYMU.NE.0)GOTO 819
       IF(J2+J1P.LT.IQ2(K))GOTO 819
       IF(J1+J2P.LT.IQ1(K))GOTO 819
       IF(ABS(J2-J1P).GT.IQ2(K))GOTO 819
       IF(ABS(J1-J2P).GT.IQ1(K))GOTO 819
       IF(MOD(J2+J1P+IQ2(K),2).NE.0)GOTO 819
       IF(MOD(J1+J2P+IQ1(K),2).NE.0)GOTO 819
       MMAX=MIN0(J1,J2,J2P-IMU(K),J1P-IMU(K))
       MMIN=MAX0(-J1,-J2,-J2P-IMU(K),-J1P-IMU(K))
       IF(MMAX.LT.MMIN)GOTO 819
      TMP2=FCOEF5(J1,J2,J12,J2P,J1P,J12P,IQ1(K),IQ2(K),IMU(K),MMAX,MMIN)
  819 IF(ABS(TMP2).LE.EPS)TMP2=ZERO

       END IF

      IF(TMP2.EQ.ZERO.AND.TMP1.EQ.ZERO)GOTO 70
      
      IF(TMP1.NE.ZERO.AND.TMP2.NE.ZERO)GOTO 80
      IF(TMP1.NE.ZERO)GOTO 81
      B(IST)=DBLE((K+2000)*ISIG)+EPSS
      BLAST=B(IST)
      IF(MOD(IPAR+J12P,2).NE.0)TMP2=-TMP2
      IF(IST.LT.IBMX)GOTO 14
      WRITE(6,82)IBMX
      STOP 'Try making NVIB1X larger in parameter.inc'
   14 B(IST+1)=TMP2*FACT1
      IST=IST+2
      GOTO 18
   81 B(IST)=DBLE((K+3000)*ISIG)+EPSS
      BLAST=B(IST)
      IF(IST.LT.IBMX)GOTO 15
      WRITE(6,82)IBMX
      STOP 'Try making NVIB1X larger in parameter.inc'
   15 B(IST+1)=TMP1*FACT1
      IST=IST+2
      GOTO 18
   80 B(IST)=DBLE((K+4000)*ISIG)+EPSS
      BLAST=B(IST)
      IF(IST.LT.IBMX)GOTO 16
      WRITE(6,82)IBMX
      STOP 'Try making NVIB1X larger in parameter.inc'
   16 B(IST+1)=TMP1*FACT1
      IF(MOD(IPAR+J12P,2).NE.0)TMP2=-TMP2
      IF(IST.LT.IBMXM1)GOTO 17
      WRITE(6,82)IBMX
      STOP 'Try making NVIB1X larger in parameter.inc'
   17 B(IST+2)=TMP2*FACT1
      IST=IST+3
      GOTO 18
   70 IF(K.NE.NUMT)GOTO 69
      IV=BLAST
      IT=SIGN(1,IV)
      IF(ISIG.EQ.IT)GOTO 69
      B(IST)=DBLE(ISIG*1000)+EPSS
      BLAST=B(IST)
      IST=IST+1
   18 IF(IST.LE.IBMX)GOTO 69
      WRITE(6,82)IBMX
      STOP 'Try making NVIB1X larger in parameter.inc'
   69 CONTINUE
      B(IST)=-DBLE(ISIG*1000)-EPSS
C     PRINT*,'IST,IWRIT,IBMX',IST,IWRIT,IBMX
      IST=IST+IWRIT*IBMX
      WRITE(6,71)IST
      IF(ICALC.EQ.1) THEN
         WRITE(6,991)
991      FORMAT(1X,'WRITING ANGULAR INTEGRALS TO UNIT 2')
         WRITE(2)IST,IWRIT,IBMX
         WRITE(2)B
      ENDIF

C***Error write out

   82 FORMAT(/1X,'Dimensions exceeded in angint. IBMX = ',I4)

C***Diagnostic write out.
C     WRITE(6,57)(B(I),I=1,MOD(IST,IBMX))

   57 FORMAT(1X,1P,12E11.4)
      WRITE(6,982)
  982 FORMAT(1X,6HANGINT)

C***Diagnostic write out.
C     WRITE(6,55)(IQ1(I),I=1,NUMT)
C     WRITE(6,982)
C     WRITE(6,55)(IQ2(I),I=1,NUMT)
C     WRITE(6,982)
C     WRITE(6,55)(IMU(I),I=1,NUMT)
C     WRITE(6,982)
C     WRITE(6,55)(JIN(I,1),I=1,NDIM)
C     WRITE(6,982)
C     WRITE(6,55)(JIN(I,2),I=1,NDIM)
C     WRITE(6,982)
C     WRITE(6,55)(JIN(I,3),I=1,NDIM)
C     WRITE(6,982)
C     WRITE(6,55)(L(I),I=1,NDIM)
   71 FORMAT(/1X,I9,44H working precision words of BPOT used in POT)
      LFIRST=.TRUE.
      RETURN
      END
      SUBROUTINE RESORT(B,ISTM,NUMT,A,IBMX)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE

C***This routine is for use with RMPROP: Version 2.1.2.
C***RESORT is called by SUBROUTINE POT (general 3-D diatom-diatom potential
C***routine, in module 'vgr3.f').
C***This subroutine removes the entries in B which are no longer
C***needed because the number of terms in the potential expansion has
C***been reduced.  ISTM is the current number of elements of B which
C***are being used and NUMT is the number of terms in the new
C***potential expansion.  On return, ISTM will contain the new number
C***of elements of B used.

      INCLUDE 'parameter.inc'
      INCLUDE 'expand.inc'
      DIMENSION B(IDX*IDX*NVIB1X),A(IDX*IDX),BU(4)

      DATA ZERO/0.0D+0/
      DATA ISCR/22/
      IST=1
      ISIGN=1
      IWRIT=0
      IBMXP1=IBMX+1
      IBMXP2=IBMXP1+1
      ISTC=0
      NSAVE=0
      NTHROW=0
      NREP=0
      WRITE(6,*)('In RESORT ISTM IS '),ISTM
      OPEN(UNIT=22,FILE='FORT.22',FORM='UNFORMATTED',STATUS='UNKNOWN')

      REWIND (22)
      DO 12 I=1,4
   12 BU(I)=B(I)
      GOTO 14

    1 CONTINUE
      ISAVE=INX
      DO 21 I=1,4-ISAVE
   21 BU(I)=BU(I+ISAVE)
      ITEMP=MOD(IST+4-ISAVE,IBMX)
      IADD=0
      IF(ITEMP.EQ.0)ITEMP=IBMX
      IF(ITEMP.NE.1)GOTO 13
   24 CONTINUE
      DO 22 I=1,ISAVE-IADD
   22 BU(I+4-ISAVE+IADD)=B(I)
      GOTO 14
   13 BU(5-ISAVE)=B(ITEMP)
      IF(ISAVE.EQ.1)GOTO 14
      ITEMP=ITEMP+1
      IF(ITEMP.GT.IBMX)ITEMP=ITEMP-IBMX
      IF(ITEMP.NE.1)GOTO 23
      IADD=1
      GOTO 24
   23 BU(6-ISAVE)=B(ITEMP)
      IF(ISAVE.EQ.2)GOTO 14
      ITEMP=ITEMP+1
      IF(ITEMP.GT.IBMX)ITEMP=ITEMP-IBMX
      IF(ITEMP.NE.1)GOTO 25
      IADD=2
      GOTO 24
   25 BU(4)=B(ITEMP)
   14 IV=INT(BU(1))
      ISIG=SIGN(1,IV)
      IV=INT(ABS(BU(1)))
      IV1=IV/1000
      INX=IV1
      IF(IV1.GE.3)INX=INX-1
      BS1=BU(1)
      BS2=BU(2)
      BS3=BU(3)
      IF(IV1.EQ.1)GOTO 3
      IV2=IV-1000*IV1
      IF(IV2.LE.NUMT)GOTO 3

C***Delete entries from list.

      NTHROW=NTHROW+1
      ISAVE=0
      ITHROW=IV1
      IF(IV1.GE.3)ITHROW=ITHROW-1
      IF(ISIGN.EQ.ISIG)GOTO 4

C***This is reached if this is a new channel pair.  Check and see if
C***this is the only nonzero entry.

      IVN=INT(BU(INX+1))
      ISIGG=SIGN(1,IVN)
      IF(ISIGG.EQ.ISIG)GOTO 4

C***This is the only entry so replace with 1000.

      ISAVE=1
      NTHROW=NTHROW-1
      NREP=NREP+1
      BS1=DBLE(ISIG*1000)
      ITHROW=ITHROW-1
      GOTO 4 

C***Save everything.

    3 ISAVE=IV1
      NSAVE=NSAVE+1
      IF(IV1.GE.3)ISAVE=ISAVE-1
      ITHROW=ZERO

C***Process ISAVE and ITHROW.

    4 IST=IST+ITHROW+ISAVE
      ISTC=ISTC+ISAVE
      ISAVE=ISAVE+1
      GOTO (5,6,7,8),ISAVE
      STOP 'Error in RESORT in vgr3.f'
    5 CONTINUE
      IF(IST.GT.ISTM)GOTO 9
      GOTO 1
   11  CONTINUE
      IF(IST.LE.ISTM)GOTO 1
      GOTO 9
    6 CONTINUE
      IF(ISTC.LE.IDX*IDX)GOTO 15
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=1
   15 A(ISTC)=BS1
      ISIGN=ISIG
      GOTO 11
    7 CONTINUE
      IF(ISTC.LE.IDX*IDX+1)GOTO 16
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=2
   16 A(ISTC-1)=BS1
      IF(ISTC.LE.IDX*IDX)GOTO 17
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=1
   17 A(ISTC)=BS2
      ISIGN=ISIG
      GOTO 11
    8 CONTINUE
      IF(ISTC.LE.IDX*IDX+2)GOTO 18
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=3
   18 A(ISTC-2)=BS1
      IF(ISTC.LE.IDX*IDX+1)GOTO 19
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=2
   19 A(ISTC-1)=BS2
      IF(ISTC.LE.IDX*IDX)GOTO 20
      WRITE(22)A
      IWRIT=IWRIT+1
      ISTC=1
   20 A(ISTC)=BS3
      ISIGN=ISIG
      GOTO 11
    9 WRITE(22)A
C***THE LINE BELOW CHANGED BY MJU01-03-93
C     ISTM=ISTC+IWRIT*IBMX
      ISTM=ISTC+IWRIT*IDX*IDX
      REWIND (22)
      DO 1033 I=1,IDX*IDX*NVIB1X
      B(I)=0.0D+0
 1033 CONTINUE
      DO 1034 I=1,IWRIT
      READ(22)A
      DO 1035 J=1,IDX*IDX
      B((I-1)*IDX*IDX+J)=A(J)
 1035 CONTINUE
 1034 CONTINUE
      READ(22)(A(I),I=1,ISTC)
      DO 1036 I=1,ISTC
      B(IWRIT*IDX*IDX+I)=A(I)
 1036 CONTINUE
      WRITE(6,10)NSAVE,NTHROW,NREP,ISTM
   10 FORMAT(1X, 9HIn RESORT,I9,19H entries were saved,I9,29H entries we
     +re thrown out, and,I9,22H entries were replaced/1X,7Hleaving,I9,24
     $H working precision words)
      RETURN
      END
