      SUBROUTINE WDATA(EIG,X,W,N,NJ,NV,N1,N2,N3,IUNIT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      INTEGER FU1
      LOGICAL LVIBJ
      SAVE       
      PARAMETER(FU1=1)                                                       

C***  This subroutine for use with RMPROP: Version 2.1.2.
C***WDATA may be called by SUBROUTINE VIBINT (from Schwenke-Truhlar 3-D HF-HF
C***potential subroutine, in module 'stpot2.f').
C***WDATA may be called by SUBROUTINE PREPOT (from arbitrary 3-D atom-diatom
C***potential subroutine, in module 'prevgr2.f).
C***WDATA may be called by SUBROUTINE POT (from arbitrary 3-D atom-diatom
C***potential subroutine, in module 'vgr2.f).
C***WDATA may be called by SUBROUTINE PREPOT (from arbitrary 3-D diatom-diatom
C***potential subroutine, in module 'prevgr3.f).
C***WDATA may be called by SUBROUTINE POT (from arbitrary 3-D diatom-diatom
C***potential subroutine, in module 'vgr3.f).
C***Get proper data from file written by program weights. 
C***EIG(I,J) eigenenergy of vib. state I-1 and rot. state J-1.
C***EIG'S first dimension is N1. 
C***X(I) I'th node. (R-RE)
C***W(I,J,K,L) I'th weight for initial J state J-1, final J state K-1, 
C***and vibrational state described by L. L=1;0,0,L=2;1,0,L=3;1,1,ETC.
C***N order of quadrature.
C***NJ maximum J+1 weights are needed for.
C***NV max V+1 weights are needed for.
C***N2 1'st dimension of W.
C***N3 2'nd 2 dimensions of W 
C***IUNIT logical unit data file containing weights etc. is assigned. 
C***IUNIT is assumed to be 1 by default.

C***LINE BELOW TEST ADDED BY MJU3-17-93 
      COMMON/LOGCM/LVIBJ
C***NEW LINES END HERE
      DIMENSION EIG(N1,*),X(*),W(N2,N3,N3,*)                            4M12R94
      IDUM=1
      REWIND IUNIT
      NDU=NV*(NV+1)/2 
      OPEN(UNIT=FU1,FILE='fort.1',STATUS='UNKNOWN',FORM='FORMATTED')

C***Read in appropriate data from FORTRAN unit 1.
C***  NSAVE is the maximum vibrational quantum number +1 for which
C***  weights and nodes had been saved on FORTRAN unit 1.
C***
C***  JSAVE is the maximum number +1 of states used in the calculation
C***  of the vibrational states.   
C***  JSAVE is 0 if no vibrational-rotational coupling was performed.
C***
C***  IHOM is a heteronuclear/homonuclear flag. It has the following
C***  meanings:
C***  IHOM = 0 for heteronuclear diatoms (all J states necessary)
C***  IHOM = 1 for homonuclear diatoms (using only odd J states)
C***  IHOM = 2 for homonuclear diatoms (using only even J states)

      READ(IUNIT,1)NSAVE,JSAVE,IHOM
      WRITE(6,9218)NSAVE,NV,JSAVE,NJ
 9218 FORMAT(/1X,20HIn SUBROUTINE WDATA /1X,24Hthe maximum vibrational ,        
     137Hquantum number + 1 for which weights ,
     29Hand nodes/1X,19Hwere performed was ,I5/1X,
     354Hthe vibrational quantum number + 1 for which they are ,
     413Hrequested is ,I5/1X,
     563Hthe maximum rotational quantum number +1 used in the calculatio
     6,9Hn of the /1X,22Hvibrational states is ,I5/1X,
     752Hthe rotational quantum number +1 for which they are ,
     813Hrequested is ,I5,1H./)
      IF(NSAVE.LT.NV.OR.JSAVE.LT.NJ)
     1 STOP 'NSAVE < NV or JSAVE < NJ in WDATA in wdata.f'
    1 FORMAT(1X,3I5)
   19 FORMAT(1X,I5)
C***LINE BELOW TEST ADDED BY MJU3-17-93 
      IF(LVIBJ.AND.NJ.EQ.1)WRITE(6,101)
      IF(LVIBJ.AND.NJ.EQ.1)STOP
      IF((.NOT.LVIBJ).AND.(NJ.GT.1))WRITE(6,101)
      IF((.NOT.LVIBJ).AND.(NJ.GT.1))STOP
  101 FORMAT(/1X,'In SUBROUTINE DATA the vib-rot coupling flags are',
     1' inconsistent')
C***NEW LINES END HERE

      NDIM=NSAVE*(NSAVE+1)/2
      ITS=NSAVE/6 
      IF(ITS*6.NE.NSAVE)ITS=ITS+1 
 
C***Read in eigenenergies, saving only those wanted.

      DO 5 I=1,JSAVE  
      IR=1  
      IF(I.GT.NJ)GOTO 6 
      READ(IUNIT,7)(EIG(J,I),J=1,NSAVE) 
      GOTO 5
    8 IF(IR.GT.ITS)GOTO 5  
    6 READ(IUNIT,7)DUM 
      IR=IR+1 
      GOTO 8
    5 CONTINUE
    7 FORMAT(1X,1P,6E21.14)
    2 CONTINUE
      READ(IUNIT,19,END=3)NPNTS  
      NLIN=NPNTS/6
      IF(NLIN*6.LT.NPNTS)NLIN=NLIN+1
 
C***Read in nodes, saving them only if the correct order.

      IF(NPNTS.EQ.N)GOTO 9
      IR=1  
   10 CONTINUE
      DO 15 I=1,NLIN  
   15 READ(IUNIT,7)DUM
      IR=IR+1 
      GOTO 11 
    9 READ(IUNIT,7)(X(I),I=1,N) 
   11 CONTINUE
 
C***Read in weights, saving only those wanted.

      DO 12 L=1,NDIM  
      DO 12 K=1,JSAVE 
      DO 12 J=1,JSAVE 
      IF(N.NE.NPNTS)GOTO 13 
      IF(L.GT.NDU)GOTO 13 
      IF(K.GT.NJ)GOTO 13
      IF(J.GT.NJ)GOTO 13
      READ(IUNIT,7)(W(I,J,K,L),I=1,N) 
      GOTO 12 
   13 CONTINUE                                                          
      DO 14 IP=1,NLIN 
   14 READ(IUNIT,7)DUM
   12 CONTINUE
      IF(N.EQ.NPNTS)RETURN
      GOTO 2
    3 WRITE(6,4)IUNIT,N 
    4 FORMAT(1X,50HUnable to find correct order of quadrature on unit,I3
     X,4H N =,I3/1X,17HAborting in WDATA) 
      STOP  
      END 
