      SUBROUTINE XMAT(KD,ND,X,IR,JC,KC,ALPHA)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***XMAT may be called by SUBROUTINE POT (collinear atom-vibrating diatom
C***potential routine, in module 'potheh2.f').
C***XMAT may be called by SUBROUTINE POT (Poulsen-Billing-Steinfeld
C***potential routine, in module 'pothfhfpbs.f').
C***This subroutine calculates all the nonzero elements of X**P for
C***P=1,...KD between harmonic oscillator wavefunctions N,M=0,1,...ND
C***using the matrix multiplication method.  All other elements are
C***set equal to ZERO.  The (N,M) element of X**P is stored in
C***X(N+1,M+1,P).  Each X(I,J,P) includes the factor ALPHA**P where
C***for an oscillator with force constant K equal to MU*(OMEGA**2)
C***ALPHA is defined ALPHA=SQRT(HBAR/(2.0*MU*OMEGA)).  IR, JC, and KC
C***are the first, second, and third dimensions of array X in the
C***calling program dimension statement and must satisfy
C***IR.GE.ND+1, JC.GE.ND+1, KC.GE.KD.
C***AL, Y, and ROOT are temporary arrays and must be dimensioned at
C***least (KD), (ND+KD,ND+KD,KD), and (ND+KD) respectively.

      COMMON/XMATCM/AL(20),Y(55,55,20),ROOT(55)
      DIMENSION X(IR,JC,KC)

C***Definitions.

      NDKD=ND+KD
      NDP1=ND+1

C***Set the necessary elements of Y to ZERO.

      DO 5 K=1,KD
         DO 5 I=1,NDKD
         DO 5 J=1,NDKD
    5    Y(I,J,K)=0.0D0

C***Calculate powers of ALPHA.  Store ALPHA**M in AL(M).

      AL(1)=ALPHA
      IF(KD.LT.2) GO TO 11
      DO 10 I=2,KD
      IM1=I-1
   10 AL(I)=AL(IM1)*ALPHA

C***Calculate square root function.  Store SQRT(M) in ROOT(M).

   11 DO 15 J=1,NDKD
      AJ=J
   15 ROOT(J)=DSQRT(AJ)

C***Assign (I,J) matrix element of X**1.  Store in Y(I+1,J+1,1).

      DO 20 M=1,NDKD
      N=M+1
      AM=M
      Y(M,N,1)=DSQRT(AM)
   20 Y(N,M,1)=Y(M,N,1)

C***Loop through powers of X.

      IF(KD.LT.2) RETURN
      DO 60 K=2,KD
      KM1=K-1
      JSTART=0
      IF(MOD(K,2).NE.0)JSTART=1
      NDKDMK=NDKD-K

C***Loop through the first NDKNMK rows.

      DO 60 I=0,NDKDMK
         IP1=I+1
         JMIN=I+JSTART
         IPK=I+K
         JMAX=MIN0(IPK,NDKDMK)
         IF(JMAX.LT.JMIN)GO TO 60

C***Loop through all columns with nonzero elements for that row.

        DO 50 J=JMIN,JMAX,2
           JP1=J+1
           JP2=J+2
           Q=Y(IP1,JP2,KM1)*ROOT(JP1)
           IF(J.NE.0)Q=Q+Y(IP1,J,KM1)*ROOT(J)
           Y(IP1,JP1,K)=Q
   50      Y(JP1,IP1,K)=Q
   60 CONTINUE
      DO 80 K=1,KD
         DO 80 I=1,NDP1
            DO 80 J=1,NDP1
               X(I,J,K)=AL(K)*Y(I,J,K)
   80 X(J,I,K)=X(I,J,K)
      RETURN
      END
