      SUBROUTINE YQQM(YY,X1,X2,X3,LMAX,IQ1,IQ2,IMU,NUMT) 
      IMPLICIT DOUBLE PRECISION   (A-H,O-Z) 
      INCLUDE 'parameter.inc'
      INCLUDE 'expand.inc'
      SAVE

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***YQQM may be called by SUBROUTINE EXPGET (from general 3-D atom-
C***vibrating diatom potential routine, in module 'vgr2.f').
C***Calculate angular functions for Launay type potential
C***expansion. YY is the output array, X1=COS(THETA1), X2=COS(THETA2), 
C***X3=PHI1-PHI2, and LMAX is the
C***maximum Q1 and Q2 found, plus 1.                                    7M25R93
C***Y(I)=YIQ1(I)IQ2(I)IMU(I). NUMT is the
C***number of IQ1'S etc to calculate.
 
      DIMENSION YY(NUMBT),P1(120),P2(120),C(15,15,15),EXP(15), 
     1FACT(30),IQ1(NUMBT),IQ2(NUMBT),IMU(NUMBT) 

C***Minimum dimensions :
C***DIMENSION P1(LMAXX),P2(LMAXX),C(LMAX,LMAX,LMAX),EXP(LMAX),
C***FACT(2*LMAX)
C***LMAXX=LMAX*(LMAX+1)/2 

      DATA MAX/15/IFIRST/0/ONE/1.0D+0/TWO/2.0D+0/FOUR/4.0D+0/ 
      IF(LMAX.GT.MAX)GOTO 10
      IF(IFIRST.EQ.LMAX)GOTO 1  
 
C***Calculate normalization constants only first time.
 
      IFIRST=LMAX 

C***Factorials.

      FACT(1)=ONE 
      DO 2 I=2,2*MAX  
    2 FACT(I)=FACT(I-1)* DBLE(I-1) 
      DO 3 L1=1,LMAX  
      F1=2*L1-1 
      DO 3 L2=1,LMAX  
      F2=2*L2-1 
      FA=F1*F2
      MMIN=MIN0(L1,L2)
      DO 3 M=1,MMIN 
      F3=FACT(L1-M+1) 
      F4=FACT(L2-M+1) 
      F5=FACT(L1+M-1) 
      F6=FACT(L2+M-1) 
      F7=ONE
      IF(M.EQ.1)F7=TWO
      F8=DSQRT(TWO*FA*F3*F4/(F5*F6*F7))
      IF(MOD(M,2).EQ.0)F8=-F8 
    3 C(L1,L2,M)=F8 

C***Done.

    1 CONTINUE

C***Calculate functions at these angles.

      DO 4 M=1,LMAX 
    4 EXP(M)=COS(DBLE(M-1)*X3)

      CALL PLM(LMAX,P1,X1)
      CALL PLM(LMAX,P2,X2)
      DO 5 I=1,NUMT 
      L1=IQ1(I)+1 
      L2=IQ2(I)+1 
      M=IMU(I)+1
      K1=L1*(L1-1)/2+M
      K2=L2*(L2-1)/2+M
      YY(I)=C(L1,L2,M)*P1(K1)*P2(K2)*EXP(M)
    5 CONTINUE
      RETURN
   10 WRITE(6,11)LMAX,LMAX
   11 FORMAT(1X,46HLMAX is greater than dimensions in YQQM. LMAX=,I5, 
     1F3.0) 
      STOP 'In module yqqm.f' 
      END 
      SUBROUTINE PLM(LMAX,P,X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 

C***This subroutine is for use with RMPROP: Version 2.1.2.
C***PLM is called by YQQM (routine to calculate normalized Launay functions,
C***in module 'yqqm.f').
C***This program calculates PLM(X) for all L,M up to LMAX-1. PLM(X) 
C***is returned in P(L*(L+1)/2+M+1).
 
      DIMENSION P(120)  
      DATA ONE/1.0D+0/
      P3(P1,P2,Y,I,J)=( DBLE(2*I+1)*Y*P2- DBLE(I+J)*P1)/ DBLE(I-J+1) 
      P4(P1,P2,Y,I,J)=( DBLE(I-J)*Y*P2- DBLE(I+J)*P1)/DSQRT(ONE-Y*Y) 
      P(1)=ONE
      IF(LMAX.EQ.1)RETURN 
      P(2)=X
      IF(X.EQ.ONE)STOP 'Error PLM in module yqqm.f'
      P(3)=P4(P(1),P(2),X,1,0)
      IF(LMAX.EQ.2)RETURN 
      J1=1  
      J2=2  
      J3=4  
      DO 1 I1=3,LMAX  
      I=I1-2
      P(J3)=P3(P(J1),P(J2),X,I,0) 
      J1=J2 
      J2=J3 
    1 J3=J3+I1
      DO 2 J1=2,LMAX  
      J=J1-1
      JM=J-1
      DO 2 I1=J1,LMAX 
      IF(I1.EQ.2)GOTO 2 
      I=I1-1
      K1=I*(I-1)/2+J
      ITEMP=I1*I/2
      K2=ITEMP+J
      K3=ITEMP+J1 
      P(K3)=P4(P(K1),P(K2),X,I,JM)
    2 CONTINUE
      RETURN
      END 
